package com.yizhi.course.application.feign;

import com.yizhi.course.application.vo.CourseDashboardParam;
import com.yizhi.course.application.vo.CourseDashboardVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.Map;

/**
 * 课程资源授权管理
 *
 * @author Fairyland
 */
@FeignClient(name = "course", contextId = "CourseDashboardClient")
public interface CourseDashboardClient {

    @PostMapping("/dashboard/getCourseDashboardData")
    public Map<Long, CourseDashboardVO> getCourseDashboardData(@RequestBody CourseDashboardParam param);

    /**
     * 根据时间站点  获取《用户id,时间内的累计学习时长》
     *
     * @param param
     * @return
     */
    @PostMapping("/dashboard/getCourseStudyTime")
    public Map<Long, Long> getCourseStudyTime(@RequestBody CourseDashboardParam param);

    /**
     * 根据时间实时获取当前用户课程的累计学习时间
     *
     * @param startDate
     * @param endDate
     * @return
     */
    @GetMapping("/dashboard/todayStudyTime")
    public Long todayStudyTime(@RequestParam("startDate") String startDate, @RequestParam("endDate") String endDate);

    /**
     * 实时获取浏览课程数
     *
     * @return
     */
    @GetMapping("/dashboard/viewRecords/getCount")
    public Integer getViewRecordsCount();
}
