package com.yizhi.course.application.feign;

import com.yizhi.course.application.vo.CourseStudyDrRankInfoVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

@FeignClient(name = "course", contextId = "CourseStudyHourRankingClient")
public interface CourseStudyHourRankingClient {

    /**
     * 查询当前人的排名和站点排名列表
     * @param siteId
     * @param accountId
     * @return
     */
    @GetMapping("/studyHour/ranking/info")
    CourseStudyDrRankInfoVO getListBySiteId(@RequestParam("siteId") Long siteId,
                                            @RequestParam("accountId") Long accountId);

    /**
     * 异步生成站点排名信息
     * @param siteId
     * @return
     */
    @GetMapping("/studyHour/ranking/generated")
    boolean rankingGenerated(@RequestParam("siteId") Long siteId);
}
