package com.yizhi.course.application.feign;

import com.yizhi.course.application.vo.ClassifyVo;
import com.yizhi.course.application.vo.MarketingClassifyVo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * @Author: XieHaijun
 * @Description: 营销课程分类
 * @Date: Created in 9:34 2018/4/10
 * @Modified By
 */
@FeignClient(name = "course", contextId = "MarketingClassifyClient")
public interface MarketingClassifyClient {
    /*************************  营销分类接口 *********************************/
    @RequestMapping(value = "/marketing/classify/save",method = RequestMethod.POST)
    public MarketingClassifyVo saveClassify(@RequestBody MarketingClassifyVo marketingClassifyVo);

    @RequestMapping(value = "/marketing/classify/delete",method = RequestMethod.GET)
    public boolean deleteClassify(@RequestParam(value = "id") Long id);

    @RequestMapping(value = "/marketing/classify/update",method = RequestMethod.POST)
    public boolean updateClassify(@RequestBody MarketingClassifyVo marketingClassifyVo);

    @RequestMapping(value = "/marketing/classify/list",method = RequestMethod.GET)
    public List<ClassifyVo> listClassify();

    @RequestMapping(value = "/marketing/classify/view",method = RequestMethod.GET)
    public ClassifyVo viewClassify(@RequestParam(value = "id") Long id);

    @RequestMapping(value = "/marketing/classify/name/get",method = RequestMethod.GET)
    public ClassifyVo getByName(@RequestParam(value = "name") String name,@RequestParam("siteId") Long siteId,
                                @RequestParam(value = "classifyId",required = false) Long classifyId);

}
