package com.yizhi.course.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.course.application.vo.OfflineClassifyVo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;

@FeignClient(name = "course", contextId = "OfflineClassifyClient")
public interface OfflineClassifyClient {

    /**
     * 根据id删除线下课程分类
     * notice: 只能删除没有子分类的实体
     *
     * @param
     * @return
     */
    @PostMapping("/manage/offlineClassify/delete")
    Integer delete(@RequestBody Map<String, String> map);

    /**
     * 添加线下课程分类
     *
     * @param offlineClassify
     * @return
     */
    @PostMapping("/manage/offlineClassify/save")
    Integer saveOfflineClassify(@RequestBody OfflineClassifyVo offlineClassify);

    /**
     * 修改线下课程分类
     *
     * @param offlineClassify
     * @return
     */
    @PostMapping("/manage/offlineClassify/update")
    Integer updateOfflineClassify(@RequestBody OfflineClassifyVo offlineClassify);

    /**
     * 查询线下课程分类
     *
     */
    @PostMapping("/manage/offlineClassify/list")
    List<OfflineClassifyVo> listOfflineClassify();

    /**
     * 线下课程分类排序
     *
     * @param list
     * @return
     */
    @PostMapping("/manage/offlineClassify/sort/update")
    Integer offlineClassifySort(@RequestBody List<OfflineClassifyVo> list);

    /**
     * 线下课程分类分页查询
     *
     * @param name
     * @param pageNo
     * @param pageSize
     * @return
     */
    @GetMapping("/manage/offlineClassify/page/list")
    Page<OfflineClassifyVo> pageList(
            @RequestParam(name = "name", required = false) String name,
            @RequestParam(name = "pageNo") Integer pageNo,
            @RequestParam(name = "pageSize") Integer pageSize);
}
