package com.yizhi.course.application.feign;

import com.yizhi.course.application.vo.CourseStudyHourVO;
import com.yizhi.course.application.vo.ShenWanHongYuanCourseVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(name = "course", contextId = "ShenWanHongYuanCourseClient")
public interface ShenWanHongYuanCourseClient {
	/**
	 * 按学员课程分组获取学时
	 * @param queryDay
	 * @param courseIds
	 * @return
	 */
	@GetMapping(value = "/swhy/accountcoursegroup/recordes")
	List<CourseStudyHourVO> getAccountCourseGroupRecorde(@RequestParam(name = "queryDay", required = false) Integer queryDay,
                                                         @RequestParam(name = "courseIds", required = true) List<Long> courseIds,
                                                         @RequestParam(name = "accountIds", required = false) List<Long> accountIds);
	
	/**
	 * 按学员分组获取学时
	 * @param queryDay
	 * @param accountIds
	 * @return
	 */
	@GetMapping(value = "/swhy/accountgroup/recordes")
	List<CourseStudyHourVO> getAccountRecorde(@RequestParam(name = "queryDay", required = false) Integer queryDay,
			@RequestParam(name = "courseIds", required = true) List<Long> courseIds, 
			@RequestParam(name = "accountIds", required = false) List<Long> accountIds);

	@PostMapping(value = "/swhy/accountgroup/post/recordes")
	List<CourseStudyHourVO> getAccountRecordePost(@RequestBody ShenWanHongYuanCourseVO vo);
}
