package com.yizhi.course.application.vo;


import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@Api(
        tags = {"CourseVo"},
        description = "课程接对象"
)
@Data
public class ApiListCourseVo {

    @ApiModelProperty(value = "课程id")
    private Long id;

    @ApiModelProperty(value = "业务名称")
    private String name;

    @ApiModelProperty(value = "业务编码")
    private String code;

    @ApiModelProperty(value = "课程评分")
    private Double level;

    @ApiModelProperty(value = "课程封面图")
    private String image;

    @ApiModelProperty(value = "作者")
    private String author;

    @ApiModelProperty(value = "作者单位")
    private String authorUnit;

    @ApiModelProperty(value = "1有效课程，0.失效课程")
    private Integer valid;

    @ApiModelProperty(value = "分类id")
    private Long classifyId;

    @ApiModelProperty(value = "分类名称")
    private String classifyName;

    @ApiModelProperty(value = "学习时长")
    private Integer duration;

    @ApiModelProperty(value = "课程学时")
    private Float totalDuration;

    @ApiModelProperty("课程学时显示 true 显示，false不显示")
    private Boolean courseDurationShow;

    @ApiModelProperty(value = "学习数")
    private Integer studyNum;

    @ApiModelProperty(value = "点赞数")
    private Integer likeNum;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "创建时间String")
    private String createTimeString;

    @ApiModelProperty("课程学习状态 0:表示未完成，1表示已完成 ,-1 未开始")
    private Integer studentStatus;

}
