package com.yizhi.course.application.vo;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Api(
        tags = {"ChapterDetailedInfoVO"},description = "章节详细信息"
)
@Data
public class ChapterDetailedInfoVO {

    @ApiModelProperty(value = "章节id")
    private Long id;

    @ApiModelProperty(value = "素材id")
    private Long materialId;

    @ApiModelProperty(value = "素材类型1音频 2 视频 3 文本 4 富媒体 5 Scrom (如果来源类型为3: 测验：1则为测验的01:过程性测验，2则为测验的02:总结性测验)")
    private Integer materialType;

    @ApiModelProperty(value = "课程")
    private Long courseId;

    @ApiModelProperty(value = "音频完成条件 0 播放即完成 1听完整个课程")
    private Integer audioComplete;

    @ApiModelProperty(value = "视频完成条件 0 播放即完成 1听完整个课程")
    private Integer videoComplete;

    @ApiModelProperty(value = "文档完成条件 0 观看即完成 1停留时长达到学习时长即完成")
    private Integer docComplete;

    @ApiModelProperty(value = "多媒体完成条件 0 观看即完成 1停留时长达到学习时长即完成")
    private Integer richComplete;

    @ApiModelProperty("完成时间单位：小时")
    private Integer textHour;

    @ApiModelProperty("完成时间单位：分")
    private Integer textMinute;

    @ApiModelProperty("完成时间单位：秒")
    private Integer textSecond;
}
