/**
 * FileName: ChapterDetailsVo
 * Author:   wenjunlong
 * Date:     2018/5/8 20:25
 * Description: 章节详情 带完成状态
 * History:
 * <author>          <time>          <version>          <desc>
 * 作者姓名           修改时间           版本号              描述
 */
package com.yizhi.course.application.vo;

import com.baomidou.mybatisplus.annotations.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 〈一句话功能简述〉<br> 
 * 〈章节详情 带完成状态〉
 *
 * @author wenjunlong
 * @create 2018/5/8
 * @since 1.0.0
 */
@Data
public class ChapterDetailsVo {

    public static final String NOT_EXACTLY_MSG = "notExactlyMsg";

    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "章节父id")
    @TableField("parent_id")
    private Long parentId;

    @ApiModelProperty(value = "课程")
    @TableField("course_id")
    private Long courseId;

    @ApiModelProperty(value = "层级")
    private Integer layer;

    @ApiModelProperty(value = "章节名称")
    private String name;

    @ApiModelProperty(value = "素材id")
    @TableField("material_id")
    private Long materialId;

    @ApiModelProperty(value = "素材名称")
    @TableField("material_name")
    private String materialName;

    @ApiModelProperty(value = "素材类型1音频 2 视频 3 文本 4 富媒体 5 Scrom (如果source=3测验，1对应测验01 过程测验。2对应测验的02 总结性测验)")
    @TableField("material_type")
    private Integer materialType;

    @ApiModelProperty(value = "可以获得积分")
    private Integer score;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "排序")
    private Integer sort;

    @ApiModelProperty(value = "父子关系排序")
    private String path;

    @ApiModelProperty("来源类型1 素材 2 考试 9 测验")
    private Integer source;

    @ApiModelProperty(value = "完成状态0 未完成(未开始测验) 1 已完成（测验通过） 2 测验未通过 ")
    private Integer overed;

    @ApiModelProperty(value = "完成章节百分比")
    private Integer percent;

    @ApiModelProperty(value = "章节素材内容")
    private MaterialVo materialVo;

    @ApiModelProperty(value = "测验分数")
    private Integer testScore;

    @ApiModelProperty(value = "是否是最后学习的章节")
    private Boolean isLastStudy;

    @ApiModelProperty(value = "课程章节排序字段")
    private String paths;

    @ApiModelProperty(value = "断点续播的进度点")
    private Long progress;

    @ApiModelProperty("是否显示水印 0否 1是 默认否")
    private Integer displayMark;

    @ApiModelProperty("水印类型 0个人信息 1自定义 默认个人信息")
    private Integer wordType;

    @ApiModelProperty("水印内容")
    private String word;
}
