package com.yizhi.course.application.vo;

import com.yizhi.course.application.vo.domain.ClassifyEntityVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * <p>
 * 课程分类组基本信息表
 * </p>
 *
 * @author xiehaijun
 * @since 2019-12-13
 */
@Data
@ApiModel(value="ClassifyGroupInfo对象", description="课程分类组基本信息表")
public class ClassifyGroupStudentVO {

    @ApiModelProperty(value = "主键")
    private Long id;

    @ApiModelProperty(value = "分类组名称")
    private String name;

    @ApiModelProperty(value = "分类描述")
    private String desc;

    @ApiModelProperty(value = "模版类型（1 平铺；2 两级分类；3 三级分类")
    private int templateType;

    @ApiModelProperty(value = "模版子类型（模版类型=2时候，该值1为一级二级分类，2 为二级分类三级分类）")
    private Integer templateSubType;

    @ApiModelProperty(value = "其他字段")
    private String othen;

    @ApiModelProperty(value = "分类信息")
    private List<ClassifyEntityVo> classifyData;


}
