/**
 * FileName: CourseDetailsVo
 * Author:   wenjunlong
 * Date:     2018/4/18 11:26
 * Description: 课程详情Vo
 * History:
 * <author>          <time>          <version>          <desc>
 * 作者姓名           修改时间           版本号              描述
 */
package com.yizhi.course.application.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

/**
 * 〈一句话功能简述〉<br> 
 * 〈课程详情Vo〉
 *
 * @author wenjunlong
 * @create 2018/4/18
 * @since 1.0.0
 */
@Data
public class CourseDetailsVo {

    @ApiModelProperty(value = "课程对象")
    private CourseVo courseVo;

    @ApiModelProperty(value = "章节列表")
    private List<ChapterDetailsVo> chapterVos = new ArrayList<ChapterDetailsVo>();

    @ApiModelProperty(value = "课程类型1音频 2 视频 3 文本 4 富媒体 5 Scrom")
    private Integer type;

    @ApiModelProperty(value = "素材内容")
    private MaterialVo materialVo;

    @ApiModelProperty(value = "课程平均分")
    private String level;

    @ApiModelProperty(value = "当前用户对该课程的平分")
    private String myLevel;

    @ApiModelProperty(value = "是否收藏 0 未收藏 1 已收藏")
    private String isFavorite;

    @ApiModelProperty(value = "音频视频是否缓存 0 否 1 是")
    private String isCache = "1";

    @ApiModelProperty(value = "学校课程的总时长")
    private Integer duration;

    @ApiModelProperty(value = "课程浏览人次")
    private Integer viewCount;

    @ApiModelProperty("课程学习状态 0:表示未完成，1表示已完成 ,-1 未开始")
    private Integer studentStatus;

}
