package com.yizhi.course.application.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * @Author: XieHaijun
 * @Description:
 * @Date: Created in 13:30 2018/4/9
 * @Modified By
 */
@ApiModel(
        value = "CourseShareVo",
        description = "课程分享对象"
)
@Data
public class CourseShareVo {

    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "课程ID")
    private Long courseId;

    @ApiModelProperty(value = "分享用户ID")
    private Long accountId;

    @ApiModelProperty(value = "分享的url")
    private String shareUrl;

    @ApiModelProperty(value = "分享时间")
    private Date shareTime;

    @ApiModelProperty(value = "被浏览次数")
    private Long readCount;

    @ApiModelProperty(value = "被浏览人次")
    private Integer readUserCount;

    @ApiModelProperty(value = "被推介人次")
    private Integer shareUserCount;

    @ApiModelProperty(value = "课程名称")
    private String courseName;

    @ApiModelProperty(value = "课程图片")
    private String courseImage;

    @ApiModelProperty(value = "分享用户名")
    private String name;

    @ApiModelProperty(value = "分享用户的姓名")
    private String fullName;

    @ApiModelProperty(value = "分享用户联系号码")
    private String tel;

    @ApiModelProperty(value = "第一级分享人openId（下级分享人）")
    private String firstShareId;

    @ApiModelProperty(value = "第二级分享人openId（下级分享人）")
    private String secondShareId;

    @ApiModelProperty(value = "微信头像")
    private String avatar;

    @ApiModelProperty(value = "是否有下级推介人")
    private Boolean hasNext = false;

}
