package com.yizhi.course.application.vo;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@Data
public class OfflineCourseVo {
    private Long id;

    @ApiModelProperty(value = "课程名称")
    private String name;

    @ApiModelProperty(value = "课程code")
    private String code;

    @ApiModelProperty(value = "课程封面图")
    private String image;

    @ApiModelProperty(value = "作者单位")
    @TableField("author_unit")
    private String authorUnit;

    @ApiModelProperty(value = "课程介绍")
    private String description;

    @ApiModelProperty(value = "标签")
    private String tags;

    @ApiModelProperty(value = "0 未上架 1 已上架 2草稿")
    private Integer status;

    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @TableField(value = "update_by_id")
    private Long updateById;

    @TableField(value = "update_by_name")
    private String updateByName;

    @TableField(value = "update_time")
    private Date updateTime;

    @TableField("company_id")
    private Long companyId;

    @TableField("org_id")
    private Long orgId;

    @TableField("site_id")
    private Long siteId;

    @ApiModelProperty(value = "分类id")
    @TableField("offline_classify_id")
    private Long offlineClassifyId;

    @ApiModelProperty(value = "0:默认未删除；1表示删除")
    private Integer deleted;

    @ApiModelProperty(value = "上传地址")
    @TableField("oss_url")
    private String ossUrl;

    @ApiModelProperty(value = "分类name字符串 以,分割")
    private String offlineClassifyName;

    @ApiModelProperty(value = "上传文件的名字")
    @TableField("file_name")
    private String fileName;

    @ApiModelProperty(value = "分类路径")
    @TableField("path")
    private String path;

    @ApiModelProperty(value = "上传并合并 up = 1 时")
    private Integer up;


}
