package com.yizhi.course.application.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 学习营销按用户统计
 * @author mei
 *
 */

@Data
public class ReportMarketingCourseAccountVo {
	
	@ApiModelProperty(value = "用户ID")
	private Long accountId;	
	
	@ApiModelProperty(value = "用户名")
	private String accountName;
	
	@ApiModelProperty(value = "姓名")
	private String accountFullName;
	
	@ApiModelProperty(value = "所在部门")
	private String orgName;
	
	@ApiModelProperty(value = "转发课程数（空返回0）")
	private Integer totalSend = 0;
	
	@ApiModelProperty(value = "转发次数（空返回0）")
	private Integer totalSendCount = 0;
	
	@ApiModelProperty(value = "阅读次数（空返回0）")
	private Integer totalReadCount = 0;

	@ApiModelProperty(value = "课程Id")
	private Long courseId;

	@ApiModelProperty(value = "课程名称")
	private String courseName;

	@ApiModelProperty(value = "课程Code")
	private String courseCode;

	@ApiModelProperty(value ="阅读总时长(单位：毫秒)")
	private Long readTimeSum = 0L;

	@ApiModelProperty(value ="阅读平均时长(单位：毫秒)")
	private Long readTimeAvg = 0L;

	@ApiModelProperty(value ="阅读总时长(以字符串显示)")
	private String readTimeSumStr;

	@ApiModelProperty(value ="阅读平均时长(以字符串显示)")
	private String readTimeAvgStr;

	@ApiModelProperty(value ="课程打开次数")
	private Integer openCount = 0;

	@ApiModelProperty(value ="打开/阅读的时间")
	private String dateTime;
}
