package com.yizhi.course.application.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 测验案件
 * </p>
 *
 * @author 谢海军123
 * @since 2018-10-17
 */
@Data
@ApiModel(value = "TestCaseVO", description = "测验案件VO")
public class TestCaseVO {

	@ApiModelProperty(value = "主键")
	private Long id;

	@ApiModelProperty(value = "课程id（必传）")
	private Long courseId;

	@ApiModelProperty(value = "课程的章节id（必传）")
	private Long chapterId;

	@ApiModelProperty(value = "测验信息id（必传）")
	private Long testId;

	@ApiModelProperty(value = "测验人账号id")
	private Long accountId;

	@ApiModelProperty(value = "企业id")
	private Long companyId;

	@ApiModelProperty(value = "站点id")
	private Long siteId;

	@ApiModelProperty(value = "组织id")
	private Long orgId;

	@ApiModelProperty(value = "创建时间")
	private Date createTime;

	@ApiModelProperty(value = "创建人姓名")
	private String createByName;

	@ApiModelProperty(value = "0：测验未通过；1：测验通过")
	private Integer status;

	@ApiModelProperty(value = "测试分数 在总结性测验才会有")
	private Integer testScore;

	@ApiModelProperty(value = "课程测验设定的合格分数")
	private Integer score;

	@ApiModelProperty(value = "课程案件答题的详细信息（必传）")
	private List<TestCaseInfoVO> testCaseInfoVOList;

}
