package com.yizhi.course.application.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 测验表
 * </p>
 *
 * @author 谢海军
 * @since 2018-10-11
 */
@Data
@ApiModel(value = "TestInfoViewRespVO", description = "根据测验信息id查询测验基本信息和题库列表信息")
public class TestInfoViewRespVO {

    @ApiModelProperty(value = "测验信息id")
	private Long id;

    @ApiModelProperty(value = "测验名称")
	private String name;

    @ApiModelProperty(value = "测验编码")
	private String code;

    @ApiModelProperty(value = "测验简介")
	private String desc;

    @ApiModelProperty(value = "测验类型：01 过程性测验；02 总结性测验")
	private String type;

    @ApiModelProperty(value = "使用状态：0 草稿；1 使用中；2 未使用； ")
	private Integer status;

    @ApiModelProperty(value = "创建时间")
	private Date createTime;

    @ApiModelProperty(value = "创建人id")
	private Long createById;

    @ApiModelProperty(value = "创建人登陆名")
	private String createByName;

    @ApiModelProperty(value = "更新时间")
	private Date updateTime;

    @ApiModelProperty(value = "更新人id")
	private Long updateById;

    @ApiModelProperty(value = "更新人登陆名")
	private String updateByName;

    @ApiModelProperty(value = "合格分数")
	private Integer passingScore;

    @ApiModelProperty(value = "课程总分")
    private Integer sumScore;

    @ApiModelProperty(value = "测验策略-题目随机：0 表示不随机（false），1表示随机")
	private Boolean subjectRandomStrategy;

    @ApiModelProperty(value = "测验策略-选项随机：0 表示不随机（false），1表示随机")
	private Boolean optionRandomStrategy;

    @ApiModelProperty(value = "测验策略-解析反馈(总结性测试)：0 表示不反馈（false），1表示反馈")
	private Boolean explainFeedbackStrategy;

    @ApiModelProperty(value = "测验策略-正误反馈(总结性测试)：0 表示不反馈（false），1表示反馈")
	private Boolean resultFeedbackStrategy;

    @ApiModelProperty(value = "测验策略-答案反馈(总结性测试)：0 表示不反馈（false），1表示反馈")
	private Boolean answerFeedbackStrategy;

    @ApiModelProperty(value = "企业id")
	private Integer companyId;

    @ApiModelProperty(value = "站点id")
	private String siteId;

    @ApiModelProperty(value = "组织id")
	private String orgId;

    @ApiModelProperty(value = "是否删除")
    private Boolean deleted;

    @ApiModelProperty(value = "测验题库")
    List<TestSubjectVO> testSubjectVOList;

    @ApiModelProperty(value = "测验策略-通过性设置(过程测验)：0 表示答对才能下一题（false），1表示提交不管对错都能进行下一题")
    private Boolean passedSetting;

    @ApiModelProperty(value = "关键字,逗号分隔")
    private String keywords;

}
