package com.yizhi.course.application.vo.domain;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 课程章节
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
@Data
@Api(tags = "ChapterEntityVo", description = "课程章节")
public class ChapterEntityVo {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "章节父id")
    private Long parentId;

    @ApiModelProperty(value = "课程")
    private Long courseId;

    @ApiModelProperty(value = "层级")
    private Integer layer;

    @ApiModelProperty(value = "章节名称")
    private String name;

    @ApiModelProperty(value = "素材id")
    private Long materialId;

    @ApiModelProperty(value = "素材名称")
    private String materialName;

    @ApiModelProperty(value = "素材类型1音频 2 视频 3 文本 4 富媒体 5 Scrom (7 过程测验，8总结性测验 ,9 直播")
    private Integer materialType;

    @ApiModelProperty(value = "可以获得积分")
    private Integer score;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "排序")
    private Integer sort;

    @ApiModelProperty(value = "父子关系排序")
    private String path;

    @ApiModelProperty("来源类型1 素材 2 考试 9: 测验")
    private Integer source;

    @ApiModelProperty(value = "素材编码")
    private String materialCode;

    @ApiModelProperty(value = "复制前章节的id")
    private Long chapterBeforeId;

    @ApiModelProperty(value = "复制标志")
    private Long indexId;

    @ApiModelProperty(value = "完成状态0 未完成 1 已完成")
    private Integer overed;

    private Long createById;

    private Date createTime;

    private Long updateById;

    private Date updateTime;

}
