package com.yizhi.course.application.vo.domain;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 素材库
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
@Data
@Api(tags = "MaterialEntityVo", description = "素材库")
public class MaterialEntityVo {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "素材编码")
    private String code;

    @ApiModelProperty(value = "素材名称")
    private String name;
    
    @ApiModelProperty(value = "素材介绍")
    private String content;

    @ApiModelProperty(value = "1音频 2 视频 3 文本 4 富媒体 5 Scrom 6 考试")
    private Integer type;

    @ApiModelProperty("1 外部采购 2 外部定制 3 内部定制 4 做课")
    private Integer source;

    @ApiModelProperty(value = "做课归属学员")
    private Long accountId;

    @ApiModelProperty(value = "制作人")
    private String producer;

    @ApiModelProperty(value = "标签")
    private String tags;

    @ApiModelProperty(value = "小时")
    private Integer textHour;

    @ApiModelProperty(value = "分")
    private Integer textMinute;

    @ApiModelProperty(value = "秒")
    private Integer textSecond;

    @ApiModelProperty(value = "源文件url")
    private String originalFileUrl;

    @ApiModelProperty(value = "源文件名，带后缀")
    private String originalFile;

    private Long createById;

    private String createByName;

    private Date createTime;

    private Long updateById;

    private String updateByName;

    private Date updateTime;

    private Long orgId;

    private Long companyId;

    private Long siteId;
    
    private Integer state;

    @ApiModelProperty(value = "上传源文件大小")
    private String size;

    @ApiModelProperty(value = "考试关联id")
    private Long examId;

    @ApiModelProperty(value = "考试名称")
    private String examName;

    @ApiModelProperty(value = "保利威视vid")
    private String polyVid;

    @ApiModelProperty(value = "是否显示水印 0否 1是 默认否")
    private Integer displayMark;
    
    @ApiModelProperty(value = "水印类型 0个人信息 1自定义 默认个人信息")
    private Integer wordType;
    
    @ApiModelProperty(value = "水印内容")
    private String word;
    

}
