package com.yizhi.course.application.controller;


import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.course.application.domain.Comment;
import com.yizhi.course.application.domain.Reply;
import com.yizhi.course.application.service.ICommentService;
import com.yizhi.course.application.service.IReplyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 * 评论 前端控制器
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
@RestController
@RequestMapping("/comment")
public class CommentController {

    @Autowired
    IdGenerator idGenerator;
    @Autowired
    private ICommentService icommentService;
    @Autowired
    private IReplyService iReplyService;

    /**
     * 管理端 审核评论
     * @param comment
     * @return
     */
    @PostMapping("/auditComment")
    public String auditComment(@RequestBody Comment comment) {

        //根据评论Id查询评论对象
        Comment comment1 = icommentService.selectById(comment.getId());
        //修改评论状态并添加备注
        if (!StringUtils.isEmpty(comment1)) {
            comment1.setDeleted(1);
            comment1.setRmark(comment.getRmark());
            icommentService.updateById(comment1);
            return "success";
        }
        return "error";
    }


    /**
     * 管理端 审核回复
     * @param reply
     * @return
     */
    @PostMapping("/auditreply")
    public String auditreply(@RequestBody Reply reply) {
        //根据评论Id查询评论对象
        Reply reply1 = iReplyService.selectById(reply.getId());
        //修改评论状态并添加备注
        if (StringUtils.isEmpty(reply1)) {
            return "error";
        } else {
            reply1.setDeleted(1);
            reply1.setRmark(reply.getRmark());
            //调用修改方法
            iReplyService.updateById(reply1);
            return "success";
        }
    }

    /**
     * 新增评论接口（保存）
     *
     * @param comment
     * @return
     */
    @PostMapping("/save")
    public Comment saveComment(@RequestBody Comment comment) {
        comment.setId(idGenerator.generate());
//        comment.setContent(StringEscapeUtils.escapeJava(comment.getContent()));
        if (icommentService.insert(comment)) {
            return comment;
        }
        return null;
    }

}

