package com.yizhi.course.application.controller;

import com.yizhi.course.application.task.CourseStatusSyncAsync;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping("/sync")
public class CourseStatusSyncController {

    @Autowired
    private CourseStatusSyncAsync courseStatusSyncAsync;

    @Value("${ACTIVE}")
    private String active;

    /**
     * 培训项目完成到课程
     * @return
     */
    @GetMapping("/sendFinishStatus")
    public String TrainningFinishToCourse(){
        Map<String,Object> params = new HashMap<>();
        params.put("active",active);
        courseStatusSyncAsync.execute(params, true);
        return "ok";
    }

}
