package com.yizhi.course.application.controller;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.course.application.domain.CourseGrade;
import com.yizhi.course.application.service.ICourseGradeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 回复评论 前端控制器
 * @author Fairyland
 *
 */
@RestController		
@RequestMapping("/grade")
public class GradeController {
	
	@Autowired
	private ICourseGradeService icourseGradeService;

	@Autowired
	IdGenerator idGenerator;
	
	
	/**
	 * 新增回复评论接口（保存）
	 * @param
	 * @return
	 */
	@PostMapping("/save")
	public Boolean saveGrade(@RequestBody CourseGrade grade){
		CourseGrade param = new CourseGrade();
		param.setCourseId(grade.getCourseId());
		param.setAccountId(grade.getAccountId());
		EntityWrapper<CourseGrade> wrapper = new EntityWrapper<>(param);
		List<CourseGrade> courseGrades = icourseGradeService.selectList(wrapper);
		if (courseGrades.size() > 0) {
			CourseGrade courseGrade = courseGrades.get(0);
			courseGrade.setLevel(grade.getLevel());
			return icourseGradeService.updateById(courseGrade);
		}
		grade.setId(idGenerator.generate());
		return icourseGradeService.insert(grade);
	}

	/**
	 *
	 * 对用户能否评分进行判断，已对课程进行评分的用户只能进行评论；
	 * @return
	 */
	@GetMapping("/pc/judgeWhetherSaveGrade")
	public Boolean judgeWhetherSaveGrade(@RequestParam(name="courseId")Long courseId){
		RequestContext requestContext = ContextHolder.get();
		CourseGrade param = new CourseGrade();
		param.setCourseId(courseId);
		param.setAccountId(requestContext.getAccountId());
		EntityWrapper<CourseGrade> wrapper = new EntityWrapper<>(param);
		List<CourseGrade> courseGrades = icourseGradeService.selectList(wrapper);
		if (courseGrades.size() > 0) {
			return false;  //代表数据库已存在，不能对课程进行评分
		}

		return true;
	}

	/**
	 * Pc端评分
	 *
	 * @param
	 * @return
	 */
	@PostMapping("/pc/save")
	public Integer savePcGrade(@RequestBody CourseGrade grade) {
		CourseGrade param = new CourseGrade();
		param.setCourseId(grade.getCourseId());
		param.setAccountId(grade.getAccountId());
		EntityWrapper<CourseGrade> wrapper = new EntityWrapper<>(param);
		List<CourseGrade> courseGrades = icourseGradeService.selectList(wrapper);
		if (courseGrades.size() > 0) {
			return -1;  //代表数据库已存在，不能对课程进行评分
		}
		grade.setId(idGenerator.generate());

		if (icourseGradeService.insert(grade)) {
			return 1;
		}
        return 0; //评分失败
	}
	
	
}
