package com.yizhi.course.application.controller;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import com.yizhi.course.application.domain.ScormRecord;
import com.yizhi.course.application.service.IScormRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.toolkit.CollectionUtils;
import com.yizhi.course.application.mapper.ScormRecordMapper;

@RestController
@RequestMapping("/deal/scorm")
public class ScormControllerDeal {

	/**
	 * 初始化controller
	 */
	
	@Autowired
	private ScormRecordMapper scormRecordMapper;
	
	@Autowired
	private IScormRecordService scormRecordService;
	
	SimpleDateFormat sim=new SimpleDateFormat("yyyy-MM-dd");
	
	
	@GetMapping("/deal")
	public void dealScorm() throws ParseException {
		

		
		//先删除total_study_seconds==0或者 isnull的
		scormRecordMapper.deleteRecord();
		//通过分组人和课程每天进行分组 每天每个人每个课程只保留一条数据
		List<ScormRecord> listScormRecord=scormRecordMapper.selectRecord();
		//清库 
		scormRecordMapper.delete(new EntityWrapper(new ScormRecord()));
		scormRecordService.insertBatch(listScormRecord);
		//多条数据的才进行整合，每个人每个课程的不行整合
		List<ScormRecord> listScormRecord2=scormRecordMapper.selectList111();
	if(CollectionUtils.isNotEmpty(listScormRecord2)) {
		for (int i = 0; i < listScormRecord2.size(); i++) {
			Long scormId=listScormRecord2.get(i).getScormId();
			Long accountId=listScormRecord2.get(i).getAccountId();
			//拿着这些信息去找数据，计算时长
			List<ScormRecord> list=scormRecordMapper.selectList222(accountId, scormId);
			if(list.size()==1) {
				//证明这个人关于这门课程只学习了
				ScormRecord sr=list.get(0);
				sr.setCurrentStudySeconds(sr.getTotalStudySeconds());
				scormRecordMapper.updateById(sr);
			}
			if(list.size()>1) {
				ScormRecord sr=list.get(0);
				sr.setCurrentStudySeconds(sr.getTotalStudySeconds());
				scormRecordMapper.updateById(sr);
				for (int j = 0; j < list.size()-1; j++) {
					ScormRecord sc=list.get(j);//前一天的数据
					ScormRecord scCur=list.get(j+1);//后一天的数据
					if(scCur.getTotalStudySeconds()==null) {
						scCur.setTotalStudySeconds(0L);
					}
					if(sc.getTotalStudySeconds()==null) {
						sc.setTotalStudySeconds(0L);
					}
					scCur.setCurrentStudySeconds(scCur.getTotalStudySeconds()-sc.getTotalStudySeconds());
					scCur.setStartStudyTime(scCur.getUpdateTime());
					scormRecordMapper.updateById(scCur);
					
				}
			}
			
			
		}
	}
		
		
		
	}
	
	
	protected Date addDay(Date date, int num) {
		Calendar calendar = new GregorianCalendar();
		calendar.setTime(date);
		calendar.add(calendar.DATE, num);
		date = calendar.getTime();
		return date;
	}

	
	

}
