package com.yizhi.course.application.controller;

import java.util.List;

import com.yizhi.course.application.domain.CourseStudyHour;
import com.yizhi.course.application.feign.ShenWanHongYuanCourseClient;
import com.yizhi.course.application.vo.CourseStudyHourVO;
import com.yizhi.course.application.vo.ShenWanHongYuanCourseVO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.yizhi.course.application.mapper.ShenWanHongYuanAccountRecordMapper;

@RestController
@RequestMapping("/swhy")
public class ShenWanHongYuanCourseController{

	private Logger LOGGER = LoggerFactory.getLogger(ShenWanHongYuanCourseController.class);

	@Autowired
	ShenWanHongYuanAccountRecordMapper shenWanHongYuanAccountRecordMapper;

	@GetMapping("/accountcoursegroup/recordes")
	public List<CourseStudyHourVO> getAccountCourseGroupRecorde(@RequestParam(name = "queryDay", required = false) Integer queryDay,
																@RequestParam(name = "courseIds", required = true) List<Long> courseIds,
																@RequestParam(name = "accountIds", required = false) List<Long> accountIds) {
		LOGGER.info("swhy按学员课程分组获取学习记录开始");
		if(courseIds.size() == 0){
			LOGGER.info("swhy按学员课程分组获取学习记录,课程ID条件是空");
			return null;
		}
		
		Long st = System.currentTimeMillis();
		List<CourseStudyHourVO> recordes = shenWanHongYuanAccountRecordMapper.getAccountCourseGroupRecorde(queryDay, courseIds, accountIds);
		Long et = System.currentTimeMillis();
		
		LOGGER.info("swhy按学员课程分组获取学习记录,耗时毫秒:{}", et - st);
		
		return recordes;
	}

	@GetMapping("/accountgroup/recordes")
	public List<CourseStudyHourVO> getAccountRecorde(@RequestParam(name = "queryDay", required = false) Integer queryDay,
			@RequestParam(name = "courseIds", required = true) List<Long> courseIds, 
			@RequestParam(name = "accountIds", required = false) List<Long> accountIds) {
		LOGGER.info("swhy按学员分组获取学习记录开始");
		if(courseIds.size() == 0){
			LOGGER.info("swhy按学员分组获取学习记录,课程ID条件是空");
			return null;
		}
		
		Long st = System.currentTimeMillis();
		List<CourseStudyHourVO> recordes = shenWanHongYuanAccountRecordMapper.getAccountGroupRecorde(queryDay, courseIds, accountIds);
		Long et = System.currentTimeMillis();
		
		LOGGER.info("swhy按学员分组获取学习记录,耗时毫秒:{}", et - st);
		
		return recordes;
	}


	@PostMapping("/accountgroup/post/recordes")
	public List<CourseStudyHourVO> getAccountRecordePost(@RequestBody ShenWanHongYuanCourseVO vo) {
		LOGGER.info("swhy按学员分组获取学习记录开始");
		Integer queryDay = vo.getQueryDay();
		List<Long> courseIds = vo.getCourseIds();
		List<Long> accountIds = vo.getAccountIds();
		if(courseIds.size() == 0){
			LOGGER.info("swhy按学员分组获取学习记录,课程ID条件是空");
			return null;
		}

		Long st = System.currentTimeMillis();
		List<CourseStudyHourVO> recordes = shenWanHongYuanAccountRecordMapper.getAccountGroupRecorde(queryDay, courseIds, accountIds);
		Long et = System.currentTimeMillis();

		LOGGER.info("swhy按学员分组获取学习记录,耗时毫秒:{}", et - st);

		return recordes;
	}

}
