package com.yizhi.course.application.controller;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.sql.DataSource;

import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.course.application.domain.Course;
import com.yizhi.course.application.domain.Material;
import com.yizhi.course.application.domain.ScormRecord;
import com.yizhi.course.application.domain.StatisticsCourse;
import com.yizhi.course.application.service.ICourseAccountService;
import com.yizhi.course.application.service.IStatisticsCourseService;
import com.yizhi.course.application.vo.*;
import com.yizhi.course.application.vo.domain.CourseEntityVo;
import com.yizhi.util.application.domain.Response;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.datasource.DataSourceUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.course.application.mapper.CourseMapper;
import com.yizhi.course.application.mapper.RecordeMapper;
import com.yizhi.course.application.mapper.ScormRecordMapper;
import com.yizhi.course.application.mapper.StatisticsCourseMapper;
import io.swagger.annotations.ApiOperation;

/**
 * <p>
 *  前端控制器
 * </p> 
 *
 * @author wangfeida123
 * @since 2018-07-26
 */
@RestController	
@RequestMapping("/statisticsCourse")
public class StatisticsCourseController {
	private Logger logger = LoggerFactory.getLogger(StatisticsCourseController.class);
	

	
	@Autowired
	private IStatisticsCourseService statisticsCourseService;
	
	@Autowired
	StatisticsCourseMapper statisticsCourseMapper;
	

	
	@Autowired
	private ICourseAccountService courseAccountService;
	
	@Autowired
	private RecordeMapper recordeMapper;
	
	@Autowired
	private CourseMapper courseMapper;
	
	@Autowired
	private ScormRecordMapper scormRecordMapper;
	
	 
	@Autowired
	IdGenerator idGenerator;
	
	final SimpleDateFormat sim = new SimpleDateFormat("yyyy-MM-dd");
	
	
	
	@GetMapping("/test")
	public Integer testComment() {
		
		Integer x=statisticsCourseMapper.getCommentCount(1016653835760435200L, "2018-07-10", 1016649563920281600L);
		System.out.println(x);
		return x;
	}
	
	
	
	  @ApiOperation(value = "异步加载报表", notes = "异步加载报表")
	  @GetMapping("/asynchronous/load/date")
	  public Response<String> AsynchronousCourse(@RequestParam(value="startDate",required=false) String startDate,
			  @RequestParam(value="endDate",required=false) String endDate) {
		  Map<String,Object> map=new HashMap<String,Object>();
		  map.put("startDate", startDate);
		  map.put("endDate", startDate);
		  //statisticsCourseRun.execute(map,true);
		  return Response.ok();
	  }
	  
	  
	  @Autowired
	  private DataSource dataSource;
	
	  @ApiOperation(value="测试导入数据,这是是测试用的，没有用",notes="测试导入数据,这是是测试用的，没有用")
	  @GetMapping("/asynchronous/load/date/test")
	  public Response<String> AsynchronousCourseTest() throws SQLException {
		  
		  String fieldsterminated = "'\t'";  
		  String linesterminated = "'\n'";  
		  
		  //获得连接
		  Connection conn = DataSourceUtils.getConnection(dataSource);
		  //系统文件路径
		  //String fileUrl="C:/ProgramData/MySQL/MySQL Server 5.7/Uploads/data.txt";
		  //执行sql
		  String sql="load data local infile 'sqlcsv'  into table statistics_course fields terminated by "+fieldsterminated+"enclosed by '' escaped by 'N'"+" lines terminated by "+linesterminated;
		  System.out.println(sql);
		  //sql编译
		  PreparedStatement preStatement = conn.prepareStatement(sql);
		  com.mysql.jdbc.PreparedStatement mysqlPreStatement = preStatement.unwrap(com.mysql.jdbc.PreparedStatement.class);
		  InputStream in=switchStream();
		  mysqlPreStatement.setLocalInfileInputStream(in);
		  //获得结果集
		  ResultSet result = preStatement.executeQuery();
		  conn.commit();
		  return Response.ok();
	  }
	  
	  
	  public InputStream switchStream( ) {
		  
		  
		  SimpleDateFormat  sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		  String fengefu="\t";  //tab键
		  String huanhangfu= "\n";  //换行
		  
	     StatisticsCourse stc=new StatisticsCourse();
		  //stc.setCourseId(1314L);
		 stc.setCourseCode("course编码");
		  stc.setCourseName("课程名字");
		  stc.setCourseCreateTime(new Date());
		  stc.setCourseState(1);
		  stc.setCourseDuration("0:03:50");
		  stc.setCompanyId(1314L);
		  stc.setSiteId(1314L);
		  stc.setOrgId(1314L);
		  stc.setCourseOrgName("课程所在组织名字");
		  stc.setOrgNo("课程所在部门编码");
		  stc.setWorkNum("工号");
		  stc.setAccountId(1314L);
		  stc.setName("用户名");
		  stc.setFullname("用户姓名");
		  stc.setOrgName("用户所在部门");
		  stc.setOrgParentNames("用户所在部门所有父节点名称");
		  stc.setAccountCompanyId(1314L);
		  stc.setAccountSiteId(1314L);
		  stc.setAccountOrgId(1314L);
		  stc.setLearnDuration(1314);
		  //stc.setStartTime(new Date());
		  //stc.setEndTime(new Date());
		  //stc.setFinishLearnTime(new Date());
		  //stc.setFirstFinishTime(new Date());
		  stc.setLearnState(1);
		  stc.setCanState(1);
		  stc.setJoinState(1);
		  stc.setLearnCount(1314);
		  stc.setCommentAccountCount(1314);
		  stc.setCommentCount(1314);
		  BigDecimal bd=new BigDecimal(13.14);
		  stc.setGrade(bd);
		  stc.setAccountState(1);
		  stc.setFinishCount(20);
		  stc.setLearnPoint(20);
		  stc.setLearnScore(20);
		  stc.setRecordCreateTime(new Date());
		  
		
		  List<StatisticsCourse> list=new ArrayList<StatisticsCourse>();
		  list.add(stc);
		  stc=new StatisticsCourse();
		  
		  stc.setCourseId(1314L);
			 stc.setCourseCode("course编码111");
			  stc.setCourseName("课程名字");
			  stc.setCourseCreateTime(new Date());
			  stc.setCourseState(1);
			  stc.setCourseDuration("0:03:50");
			  stc.setCompanyId(1314L);
			  stc.setSiteId(1314L);
			  stc.setOrgId(1314L);
			  stc.setCourseOrgName("课程所在组织名字");
			  stc.setOrgNo("课程所在部门编码");
			  stc.setWorkNum("工号");
			  stc.setAccountId(1314L);
			  stc.setName("用户名");
			  stc.setFullname("用户姓名");
			  stc.setOrgName("用户所在部门");
			  stc.setOrgParentNames("用户所在部门所有父节点名称");
			  stc.setAccountCompanyId(1314L);
			  stc.setAccountSiteId(1314L);
			  stc.setAccountOrgId(1314L);
			  stc.setLearnDuration(1314);
			  //stc.setStartTime(new Date());
			  //stc.setEndTime(new Date());
			  //stc.setFinishLearnTime(new Date());
			  //stc.setFirstFinishTime(new Date());
			  stc.setLearnState(1);
			  stc.setCanState(1);
			  stc.setJoinState(1);
			  stc.setLearnCount(1314);
			  stc.setCommentAccountCount(1314);
			  stc.setCommentCount(1314);
			 
			  stc.setGrade(bd);
			  stc.setAccountState(1);
			  stc.setFinishCount(20);
			  stc.setLearnPoint(20);
			  stc.setLearnScore(20);
			  stc.setRecordCreateTime(new Date());
		  
		  list.add(stc);
		  
		  StringBuilder sb=null;
	
		  sb=new StringBuilder();
		  for (StatisticsCourse sc:list) {
			  Long id=idGenerator.generate();
			  sb.append(id);                        //主键
			  sb.append(fengefu);
			  sb.append(sc.getCourseId());//课程id
			  sb.append(fengefu);
			  sb.append(sc.getCourseCode());//课程编码
			  sb.append(fengefu);
			  sb.append(sc.getCourseName());//课程名字
			  sb.append(fengefu);
			  if(sc.getCourseCreateTime()!=null) {
				  sb.append(sdf.format(sc.getCourseCreateTime()));  //课程创建时间
			  }
			  sb.append(fengefu);
			  sb.append(sc.getCourseState());
			  sb.append(fengefu);
			  sb.append(sc.getCourseDuration());
			  sb.append(fengefu);
			  sb.append(sc.getCourseOrgName());
			  sb.append(fengefu);
			  sb.append(sc.getOrgNo());
			  sb.append(fengefu);
			  sb.append(sc.getOrgId());
			  sb.append(fengefu);
			  sb.append(sc.getSiteId());
			  sb.append(fengefu);
			  sb.append(sc.getCompanyId());
			  sb.append(fengefu);
			  sb.append(sc.getAccountId());
			  sb.append(fengefu);
			  sb.append(sc.getWorkNum());
			  sb.append(fengefu);
			  sb.append(sc.getName());
			  sb.append(fengefu);
			  sb.append(sc.getFullname());
			  sb.append(fengefu);
			  sb.append(sc.getOrgName());
			  sb.append(fengefu);
			  sb.append(sc.getOrgParentNames());
			  sb.append(fengefu);
			  sb.append(sc.getAccountState());
			  sb.append(fengefu);
			  sb.append(sc.getAccountOrgId());
			  sb.append(fengefu);
			  sb.append(sc.getAccountSiteId());
			  sb.append(fengefu);
			  sb.append(sc.getAccountCompanyId());
			  sb.append(fengefu);
			  sb.append(sc.getLearnDuration());
			  sb.append(fengefu);
			  if(sc.getStartTime()!=null) {
				  sb.append(sdf.format(sc.getStartTime()));
			  }
			  sb.append(fengefu);
			  if(sc.getEndTime()!=null) {
				  sb.append(sdf.format(sc.getEndTime()));
			  }
			  sb.append(fengefu);
			  if(sc.getFinishLearnTime()!=null) {
				  sb.append(sdf.format(sc.getFinishLearnTime()));
			  }
			  sb.append(fengefu);
			  sb.append(sc.getLearnState());
			  sb.append(fengefu);
			  if(sc.getFirstFinishTime()!=null) {
				  sb.append(sdf.format(sc.getFirstFinishTime()));
			  }
			  sb.append(fengefu);
			  sb.append(sc.getCanState());
			  sb.append(fengefu);
			  sb.append(sc.getJoinState());
			  sb.append(fengefu);
			  sb.append(sc.getLearnCount());
			  sb.append(fengefu);
			  sb.append(sc.getCommentAccountCount());
			  sb.append(fengefu);
			  sb.append(sc.getCommentCount());
			  sb.append(fengefu);
			  sb.append(sc.getGrade());
			  sb.append(fengefu);
			  sb.append(sc.getFinishCount());
			  sb.append(fengefu);
			  sb.append(sc.getLearnPoint());
			  sb.append(fengefu);
			  sb.append(sc.getLearnScore());
			  sb.append(fengefu);
			  if(sc.getRecordCreateTime()!=null) {
				  sb.append(sdf.format(sc.getRecordCreateTime()));
			  }
			  sb.append(huanhangfu);
		}
		

		
		 
		  byte[] bytes = sb.toString().getBytes();  
		  InputStream in = new ByteArrayInputStream(bytes);  
		  return in;
	
	  }
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  /**
	   * 课程----图形报表
	   * @param startDate
	   * @param endDate
	   * @param companyId
	   * @param orgId
	   * @param siteId
	   * @return
	   */
	  @GetMapping("/chart/group")
	  public List<ReportStudyCourseChartsVo> chartGroup(
			  @RequestParam("startDate")String startDate,
			  @RequestParam("endDate")String endDate,
			  @RequestParam("companyId")Long companyId,
			  @RequestParam("orgId")Long orgId,
			  @RequestParam("siteId")Long siteId){
		  Date sTime = new Date();
		  
		  List<Long> orgIds = null; 
		  RequestContext requestContext = ContextHolder.get();
		  if(!requestContext.isAdmin() && !CollectionUtils.isEmpty(requestContext.getOrgIds())){
			  orgIds = requestContext.getOrgIds();
          }
		  List<ReportStudyCourseChartsVo> charts = statisticsCourseService.chartGroup(startDate, endDate, companyId, orgIds, siteId);
		  
		  Date eTime = new Date();
		  logger.info(" -----------------------------------------------按图形报表统计耗时秒:{}", (eTime.getTime() - sTime.getTime()) / 1000); 
		  return charts;
	  }
	  
	  
	  
	  
	  /**
	   * 课程---按课程统计
	   * @param kwd
	   * @param startDate
	   * @param endDate
	   * @param companyId
	   * @param orgId
	   * @param siteId
	   * @return
	   */
	  @GetMapping("/group")
	  public Page<ReportStudyCourseVo> courseGroup(
			  @RequestParam(value="kwd",required=false)String kwd,
			  @RequestParam("startDate")String startDate,
			  @RequestParam("endDate")String endDate,
			  @RequestParam("companyId")Long companyId,
			  @RequestParam("orgId")Long orgId,
			  @RequestParam("siteId")Long siteId,
			  @RequestParam(value="pageNo",required=false)Integer pageNo,
			  @RequestParam(value="pageSize",required=false)Integer pageSize){
		  Date sTime = new Date();
		  
		  
		  String kwdTrim=null;
		  if(kwd!=null&&kwd.length()>0) {
			  kwdTrim=kwd.trim();
			  if(kwdTrim.length()==0) {
				  kwdTrim=null;
			  }
		  }
		  
		  List<Long> orgIds = null; 
		  RequestContext requestContext = ContextHolder.get();
		  if(!requestContext.isAdmin() && !CollectionUtils.isEmpty(requestContext.getOrgIds())){
			  orgIds = requestContext.getOrgIds();
          }
		  Page<ReportStudyCourseVo> page = statisticsCourseService.courseGroup(kwdTrim,startDate, endDate, companyId, orgIds, siteId,pageNo,pageSize);
		  
		  Date eTime = new Date();
		  logger.info(" -----------------------------------------------按课程统计耗时秒:{}", (eTime.getTime() - sTime.getTime()) / 1000); 
		  return page;
	  }
	  
	  
	  
	  
	  
	  /**
	   * 课程----按照课程统计----详情
	   * @param accountKwd
	   * @param orgKwd
	   * @param courseId
	   * @param startDate
	   * @param endDate
	   * @param companyId
	   * @param orgId
	   * @param siteId
	   * @param pageNo
	   * @param pageSize
	   * @return
	   */
	  @GetMapping("/group/view")
	  public Map<String,Object> CourseGroupView(
			  @RequestParam(value="accountKwd",required=false)String accountKwd,
			  @RequestParam(value="orgKwd",required=false)String orgKwd,
			  @RequestParam("courseId")Long courseId,
			  @RequestParam("startDate")String startDate,
			  @RequestParam("endDate")String endDate,
			  @RequestParam(value="pageNo",required=false)Integer pageNo,
			  @RequestParam(value="pageSize",required=false)Integer pageSize){
		  
		  
		  /**
		   * 关键字去掉前后空格
		   */
		  String accountKwdTrim=null;
		  String orgKwdTrim=null;
		  if(accountKwd!=null&&accountKwd.length()>0) {
			  accountKwdTrim=accountKwd.trim();
			  if(accountKwdTrim.length()==0) {
				  accountKwdTrim=null;
			  }
		  }
		  
		  if(orgKwd!=null&&orgKwd.length()>0) {
			  orgKwdTrim=orgKwd.trim();
			  if(orgKwdTrim.length()==0) {
				  orgKwdTrim=null;
			  }
		  }
		  return statisticsCourseService.CourseGroupView(orgKwdTrim, accountKwdTrim, startDate, endDate, courseId, pageNo, pageSize);
	  }
	  
	  
	  
	  
	  
	  /**
	   * 按照用户统计
	   * @param accountKwd
	   * @param orgKwd
	   * @param startDate
	   * @param endDate
	   * @param companyId
	   * @param orgId
	   * @param siteId
	   * @return
	   */
	  @GetMapping("/account/group")
	  public Page<ReportStudyCourseAccountVo> courseAccountGroup(
			  @RequestParam(value="accountKwd",required=false)String accountKwd,
			  @RequestParam(value="orgKwd",required=false)String orgKwd,
			  @RequestParam("startDate")String startDate,
			  @RequestParam("endDate")String endDate,
			  @RequestParam("companyId")Long companyId,
			  @RequestParam("orgId")Long orgId,
			  @RequestParam("siteId")Long siteId,
			  @RequestParam(value="pageNo",required=false)Integer pageNo,
			  @RequestParam(value="pageSize",required=false)Integer pageSize){
		  
		  Date sTime = new Date();
		  
		  
		  
		  /**
		   * 关键字去掉前后空格
		   */
		  String accountKwdTrim=null;
		  String orgKwdTrim=null;
		  if(accountKwd!=null&&accountKwd.length()>0) {
			  accountKwdTrim=accountKwd.trim();
			  if(accountKwdTrim.length()==0) {
				  accountKwdTrim=null;
			  }
		  }
		  
		  if(orgKwd!=null&&orgKwd.length()>0) {
			  orgKwdTrim=orgKwd.trim();
			  if(orgKwdTrim.length()==0) {
				  orgKwdTrim=null;
			  }
		  }
		  
		  List<Long> orgIds = null; 
		  RequestContext requestContext = ContextHolder.get();
		  if(!requestContext.isAdmin() && !CollectionUtils.isEmpty(requestContext.getOrgIds())){
			  orgIds = requestContext.getOrgIds();
          }
		  Page<ReportStudyCourseAccountVo> page = statisticsCourseService.courseAccountGroup(orgKwdTrim, accountKwdTrim, startDate, 
				  endDate, companyId, orgIds, siteId,pageNo,pageSize);
		  
		  Date eTime = new Date();
		  logger.info(" -----------------------------------------------按照用户统计耗时秒:{}", (eTime.getTime() - sTime.getTime()) / 1000); 
		  return page;
	  }
	  
	  
	  
	  
	  
	  
	  
	  
	  @GetMapping("/account/group/export")
	  public Page<ReportStudyCourseAccountVo> courseAccountGroupExport(
			  @RequestParam(value="accountKwd",required=false)String accountKwd,
			  @RequestParam(value="orgKwd",required=false)String orgKwd,
			  @RequestParam("startDate")String startDate,
			  @RequestParam("endDate")String endDate,
			  @RequestParam("companyId")Long companyId,
			  @RequestParam("orgId")Long orgId,
			  @RequestParam("siteId")Long siteId,
			  @RequestParam(value="pageNo",required=false)Integer pageNo,
			  @RequestParam(value="pageSize",required=false)Integer pageSize){
		  
		  Date sTime = new Date();
		  
		  
		  
		  /**
		   * 关键字去掉前后空格
		   */
		  String accountKwdTrim=null;
		  String orgKwdTrim=null;
		  if(accountKwd!=null&&accountKwd.length()>0) {
			  accountKwdTrim=accountKwd.trim();
			  if(accountKwdTrim.length()==0) {
				  accountKwdTrim=null;
			  }
		  }
		  
		  if(orgKwd!=null&&orgKwd.length()>0) {
			  orgKwdTrim=orgKwd.trim();
			  if(orgKwdTrim.length()==0) {
				  orgKwdTrim=null;
			  }
		  }
		  
		  List<Long> orgIds = null; 
		  RequestContext requestContext = ContextHolder.get();
		  if(!requestContext.isAdmin() && !CollectionUtils.isEmpty(requestContext.getOrgIds())){
			  orgIds = requestContext.getOrgIds();
          }
		  Page<ReportStudyCourseAccountVo> page = statisticsCourseService.courseAccountGroupExport(orgKwdTrim, accountKwdTrim, startDate, endDate, companyId, orgIds, siteId, pageNo, pageSize);
		  
		  Date eTime = new Date();
		  logger.info(" -----------------------------------------------按照用户统计耗时秒:{}", (eTime.getTime() - sTime.getTime()) / 1000); 
		  return page;
	  }
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  @GetMapping("/account/details")
	  public List<ReportStudyCourseAccountDetailsVo> courseAccountDetails(
			  @RequestParam(value="accountKwd",required=false)String accountKwd,
			  @RequestParam(value="orgKwd",required=false)String orgKwd,
			  @RequestParam("startDate")String startDate,
			  @RequestParam("endDate")String endDate,
			  @RequestParam("companyId")Long companyId,
			  @RequestParam("orgId")Long orgId,
			  @RequestParam("siteId")Long siteId,
			  @RequestParam("pageNo")Integer pageNo,
			  @RequestParam("pageSize")Integer pageSize){
		  /**
		   * 关键字去掉前后空格
		   */
		  String accountKwdTrim=null;
		  String orgKwdTrim=null;
		  if(accountKwd!=null&&accountKwd.length()>0) {
			  accountKwdTrim=accountKwd.trim();
			  if(accountKwdTrim.length()==0) {
				  accountKwdTrim=null;
			  }
		  }
		  
		  if(orgKwd!=null&&orgKwd.length()>0) {
			  orgKwdTrim=orgKwd.trim();
			  if(orgKwdTrim.length()==0) {
				  orgKwdTrim=null;
			  }
		  }
		  
		  List<Long> orgIds = null; 
		  RequestContext requestContext = ContextHolder.get();
		  if(!requestContext.isAdmin() && !CollectionUtils.isEmpty(requestContext.getOrgIds())){
			  orgIds = requestContext.getOrgIds();
          }
		  return statisticsCourseService.courseAccountDetails(orgKwdTrim, accountKwdTrim, startDate, endDate, companyId, orgIds, siteId,pageNo,pageSize);
	  }
	  
	  
	  
	  
	  @GetMapping("/account/details/dataTotal")
	  public Integer courseAccountDetailsDataTotal(
			  @RequestParam(value="accountKwd",required=false)String accountKwd,
			  @RequestParam(value="orgKwd",required=false)String orgKwd,
			  @RequestParam("startDate")String startDate,
			  @RequestParam("endDate")String endDate,
			  @RequestParam("companyId")Long companyId,
			  @RequestParam("orgId")Long orgId,
			  @RequestParam("siteId")Long siteId){
		  /**
		   * 关键字去掉前后空格
		   */
		  String accountKwdTrim=null;
		  String orgKwdTrim=null;
		  if(accountKwd!=null&&accountKwd.length()>0) {
			  accountKwdTrim=accountKwd.trim();
			  if(accountKwdTrim.length()==0) {
				  accountKwdTrim=null;
			  }
		  }
		  
		  if(orgKwd!=null&&orgKwd.length()>0) {
			  orgKwdTrim=orgKwd.trim();
			  if(orgKwdTrim.length()==0) {
				  orgKwdTrim=null;
			  }
		  }
		  
		  List<Long> orgIds = null; 
		  RequestContext requestContext = ContextHolder.get();
		  if(!requestContext.isAdmin() && !CollectionUtils.isEmpty(requestContext.getOrgIds())){
			  orgIds = requestContext.getOrgIds();
          }
		  return statisticsCourseService.courseAccountDetailsDataTotal(orgKwdTrim, accountKwdTrim, startDate, endDate, companyId, orgIds, siteId);
	  }
	  
	  
	  
	  
	  /**
	   * 按照用户统计----查看详情
	   * @param accountId
	   * @param startDate
	   * @param endDate
	   * @param pageNo
	   * @param pageSize
	   * @return
	   */
	  @GetMapping("/account/group/view")
	  public Map<String,Object> courseAccountGroupView(
			  @RequestParam("accountId")Long accountId,
			  @RequestParam(value="kwd",required=false)String kwd,
			  @RequestParam("startDate")String startDate,
			  @RequestParam("endDate")String endDate,
			  @RequestParam(value="pageNo",required=false)Integer pageNo,
			  @RequestParam(value="pageSize",required=false)Integer pageSize){
		  
		  String kwdTrim=null;
		  if(kwd!=null&&kwd.length()>0) {
			  kwdTrim=kwd.trim();
			  if(kwdTrim.length()==0) {
				  kwdTrim=null;
			  }
		  }
		  return statisticsCourseService.courseAccountGroupView(accountId,kwdTrim, startDate, endDate, pageNo, pageSize);
	  }
	  
	  
	  
	  
	  
	  /**
	   * 按照部门统计
	   * @param kwd
	   * @param startDate
	   * @param endDate
	   * @param companyId
	   * @param orgId
	   * @param siteId
	   * @return
	   */
	  @GetMapping("/org/group")
	  public Page<ReportStudyCourseOrgVo> courseOrgGroup(
			  @RequestParam(value="kwd",required=false)String kwd,
			  @RequestParam("startDate")String startDate,
			  @RequestParam("endDate")String endDate,
			  @RequestParam("companyId")Long companyId,
			  @RequestParam("orgId")Long orgId,
			  @RequestParam("siteId")Long siteId,
			  @RequestParam(value="pageNo",required=false)Integer pageNo,
			  @RequestParam(value="pageSize",required=false)Integer pageSize){
		  
		  Date sTime = new Date();
		  
		  
		  String kwdTrim=null;
		  if(kwd!=null&&kwd.length()>0) {
			  kwdTrim=kwd.trim();
			  if(kwdTrim.length()==0) {
				  kwdTrim=null;
			  }
		  }
		  List<Long> orgIds = null; 
		  RequestContext requestContext = ContextHolder.get();
		  if(!requestContext.isAdmin() && !CollectionUtils.isEmpty(requestContext.getOrgIds())){
			  orgIds = requestContext.getOrgIds();
          }
		  Page<ReportStudyCourseOrgVo> page = statisticsCourseService.courseOrgGroup(kwdTrim, startDate, endDate, companyId, orgIds, siteId,pageNo,pageSize);
		  
		  Date eTime = new Date();
		  logger.info(" -----------------------------------------------按部门统计耗时秒:{}", (eTime.getTime() - sTime.getTime()) / 1000); 
		  
		  return page;
	  }
	  
	  
	  
	  
	  
	  
	  
	  

	  
	  
	  
	  
	  /**
	   * 下边的报表服务用到的
	   */
	  @GetMapping("/get/statis/course/message")
	  public StatisCourse getStatisCourseMessage(@RequestParam(value="companyIdParam",required=false)Long companyIdParam,@RequestParam(value="siteIdParam",required=false)Long siteIdParam) {
		  StatisCourse sc=new StatisCourse();
		  //所有课程信息

		  List<Course> list = statisticsCourseMapper.getAllCourseReport(companyIdParam,siteIdParam);
		  List<CourseEntityVo> vos = new ArrayList<>();
		  for (Course course : list) {
			  CourseEntityVo vo = new CourseEntityVo();
			  BeanUtils.copyProperties(course,vo);
			  vos.add(vo);
		  }
		  sc.setListCourse(vos);
		  //最小的课程创建时间
		  sc.setMinCourseCreateTime(statisticsCourseMapper.selectRecordMinTime());
		  return sc;
		  
	  }
	  
	  
	  @GetMapping("/get/all/siteId")
	  public List<Long> getAllSiteId(){
		  return courseMapper.getAllSiteId();
	  }
	  
	  
	  @GetMapping("/get/statis/course/relationId/by/courseId")
	  public CourseAccountReport listCourseAccountByCourseId(@RequestParam("id")Long id){
		  return courseAccountService.listCourseAccountByCourseIdReprot(id);
	  }
	  
	  
	  @GetMapping("/get/statis/course/materialtime/by/courseId")
	  public String getMaterialtimeByCourseId(@RequestParam("cId") Long cId) {
		  List<Long> ids=new ArrayList<Long>();
		  ids.add(cId);
		  List<Material> materialList = statisticsCourseMapper.getCourseDurationById(ids);
			String courseDuration = "0:0:0";
			//有些课程是没有时间长度的
			Material material=null;
			if(CollectionUtils.isNotEmpty(materialList)) {
				material=materialList.get(0);
			}
			if (material != null) {
				Integer courseHour = material.getTextHour() == null ? 0 : material.getTextHour();
				Integer courseMinute = material.getTextMinute() == null ? 0 : material.getTextMinute();
				Integer courseSecond = material.getTextSecond() == null ? 0 : material.getTextSecond();
				
				Integer timeS = courseHour * 3600 + courseMinute * 60 + courseSecond;
				Integer hour = timeS / 3600;
				Integer minute = (timeS - hour * 3600) / 60;
				Integer second = timeS - hour * 3600 - minute * 60;
				//课程时间长度
				courseDuration = hour + ":" + minute + ":" + second;
			}
		  return courseDuration;
	  }
	  
	  
	  @GetMapping("/get/statis/course/recorde/by/courseId")
	  public List<StatisticsCourseRecorde> getCourseRecordeByCourseId(@RequestParam("cId")Long cId,@RequestParam("startDate")String startDate,@RequestParam("endDate")String endDate,@RequestParam("type")Integer type) {
		  if(type==0) {
			  /*学习次数能一次统计出来，干嘛要分开统计下面注释的代码是什么思路？？？？？（分开统计非常影响报表跑批执行效率）
			 	
			  //思路   1先统计下来每个人哪天学习了,多余的记录不能记为1，因为心跳也会产生记录
			  
			  List<StatisticsCourseRecorde> listStatisticsCourseRecordeNoLearnCount=recordeMapper.getCourseRecordeByCourseIdStep1(cId, startDate, endDate);
			  if(CollectionUtils.isNotEmpty(listStatisticsCourseRecordeNoLearnCount)) {
				  
				  for (StatisticsCourseRecorde statisticsCourseRecorde : listStatisticsCourseRecordeNoLearnCount) {
					Long accountId=statisticsCourseRecorde.getAccountId();
					Date selectDate=statisticsCourseRecorde.getRecordeTime();
					if(selectDate!=null) {
						String selectDateString=sim.format(selectDate);
						Long learnCount=recordeMapper.learnCountByCourseIdAndAccountIdAndSelectDate(cId, accountId, selectDateString);
						if(learnCount==null) {
							learnCount=0L;
							statisticsCourseRecorde.setLearnCount(learnCount);
						}
						else {
							statisticsCourseRecorde.setLearnCount(learnCount);
						}
					}
				}
			  }
			  //学习次数已经整合的
			  return listStatisticsCourseRecordeNoLearnCount;
			  */
			  return recordeMapper.getCourseRecordeByCourseId(cId, startDate,endDate);
		  }
		  if(type==1) {
			  List<StatisticsCourseRecorde> list = new ArrayList<StatisticsCourseRecorde>();
			  //recorde也有记录也可通过recorde记录
			  List<StatisticsCourseRecorde> recordeByCourseId = recordeMapper.getCourseRecordeByCourseId(cId, startDate,endDate);
			  List<StatisticsCourseRecorde> scormCourseRecordeByCourseId = scormRecordMapper.getScormCourseRecordeByCourseId(cId, startDate, endDate);
			  if (CollectionUtils.isNotEmpty(recordeByCourseId)) {
				  list.addAll(recordeByCourseId);
			  }
			  if (CollectionUtils.isNotEmpty(scormCourseRecordeByCourseId)) {
				  list.addAll(scormCourseRecordeByCourseId);
			}
			  return list;
		  }
		return null;
		 
	  }
	  
	  
	  
	  @GetMapping("/get/statis/course/message/by/courseId")
	  public List<StatisticsCourseMessage> getCourseMessageByCourseId(@RequestParam("cId")Long cId,@RequestParam("startDate")String startDate,@RequestParam("endDate")String endDate,@RequestParam("siteId")Long siteId){
		  return recordeMapper.getCourseMessageByCourseId(cId, startDate,endDate, siteId);
	  }
	  
	  
	  @GetMapping("/get/statis/course/mintime/by/courseId")
	  public Date getCourseMinTimeByCourseId(@RequestParam("id")Long cId) {
		  return recordeMapper.getCourseMinTimeByCourseId(cId);
	  }
	  
	  @GetMapping("/get/statis/course/grade")
	  public List<ScormRecord> getCourseGrade(){
		  return recordeMapper.getCourseGrade();
	  }
	  
	  
	  
	  

}

