package com.yizhi.course.application.controller;


import com.yizhi.application.orm.util.QueryUtil;
import com.yizhi.course.application.domain.TestSubject;
import com.yizhi.course.application.domain.TestSubjectOption;
import com.yizhi.course.application.service.ITestSubjectOptionService;
import com.yizhi.course.application.service.ITestSubjectService;
import com.yizhi.course.application.vo.TestSubjectOptionVO;
import com.yizhi.course.application.vo.TestSubjectVO;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 测验试题 前端控制器
 * </p>
 *
 * @author 谢海军123
 * @since 2018-10-11
 */
@RestController
@RequestMapping("/testSubject")
public class TestSubjectController {

    @Autowired
    private ITestSubjectService testSubjectService;

    @Autowired
    private ITestSubjectOptionService optionService;

    @PostMapping("/save")
    public TestSubjectVO save(@RequestBody TestSubjectVO vo){
        // 保存测验试题信息
        return testSubjectService.saveTestSubject(vo);
    }

    @GetMapping("/delete")
    public boolean delete(@RequestParam("id") Long id){
        return testSubjectService.deleteAndSort(id);
    }

    @GetMapping("/view")
    public TestSubjectVO view(@RequestParam("id") Long id) {
        TestSubjectVO vo = new TestSubjectVO();
        TestSubject testSubject = new TestSubject();
        testSubject.setId(id);
        TestSubject retData = testSubjectService.selectOne(QueryUtil.condition(testSubject));
        if(retData != null){
            BeanUtils.copyProperties(retData,vo);

            TestSubjectOption testSubjectOption = new TestSubjectOption();
            testSubjectOption.setTestSubjectId(id);
            List<TestSubjectOption> retList = optionService.selectList(QueryUtil.condition(testSubjectOption));
            if(CollectionUtils.isNotEmpty(retList)){
                List<TestSubjectOptionVO> listData = new ArrayList<>();
                retList.forEach(obj->{
                    TestSubjectOptionVO data = new TestSubjectOptionVO();
                    BeanUtils.copyProperties(obj,data);
                    listData.add(data);
                });
                vo.setOptionVOS(listData);
            }
        }

        return vo;
    }

    @GetMapping("/sort")
    public TestSubjectVO sort(@RequestParam("id") Long id, @RequestParam("moveType") String moveType){

        return testSubjectService.sort(id,moveType );
    }

    @GetMapping("/score/update")
    public boolean updateScore(@RequestParam("id") Long id, @RequestParam("score") Integer score){
        TestSubject obj = new TestSubject();
        obj.setId(id);
        obj.setScore(score);
        testSubjectService.updateById(obj);
        return true;
    }

}

