package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 *
 * </p>
 *
 * @author lilingye
 * @since 2018-06-07
 */
@Data
@Api(tags = "Accredit", description = "")
@TableName("accredit")
public class Accredit extends Model<Accredit> {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "授权id")
    private Long id;

    @ApiModelProperty(value = "企业id")
    @TableField("company_id")
    private Long companyId;

    @ApiModelProperty(value = "企业名称")
    @TableField("company_name")
    private String companyName;

    @ApiModelProperty(value = "站点id")
    @TableField("site_id")
    private Long siteId;

    @ApiModelProperty(value = "站点名称")
    @TableField("site_name")
    private String siteName;

    @ApiModelProperty(value = "授权之前课程id")
    @TableField("course_id_before")
    private Long courseIdBefore;

    @ApiModelProperty(value = "0:默认未删除；1表示删除")
    @TableField("del_flg")
    private Integer delFlg;

    @ApiModelProperty(value = "来源企业id")
    @TableField("source_company_id")
    private Long sourceCompanyId;

    @ApiModelProperty(value = "授权站点id")
    @TableField("accredit_site_id")
    private Long accreditSiteId;

    @ApiModelProperty(value = "授权时间")
    @TableField("accredit_time")
    private Date accreditTime;

    @ApiModelProperty(value = "授权之后课程id")
    @TableField("course_id_after")
    private Long courseIdAfter;

    @ApiModelProperty(value = "0草稿，1授权")
    @TableField("sale_authorize_status")
    private Integer saleAuthorizeStatus;

    @ApiModelProperty(value = "0是长期使用，1指定使用期限(授权销售)")
    @TableField("use_type")
    private Integer useType;

    @ApiModelProperty(value = "指定使用的期限。（使用截止日期）")
    @TableField("use_duration")
    private Date useDuration;

    @ApiModelProperty(value = "保存时间")
    @TableField("save_time")
    private Date saveTime;

    @ApiModelProperty(value = "1 课程授权  2课程销售")
    private Integer type;

    @ApiModelProperty(value = "站点名称")
    @TableField("site_code")
    private String siteCode;

    @ApiModelProperty(value = "失效授权")
    @TableField("valid")
    private Integer valid;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
