package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * <p>
 * 音视频
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
@Data
@Api(tags = "AudioVideo", description = "音视频")
@TableName("audio_video")
public class AudioVideo extends Model<AudioVideo> {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键")
    private Long id;

    @ApiModelProperty(value = "封面图片")
    private String image;

    @ApiModelProperty(value = "素材id")
    @TableField("material_id")
    private Long materialId;

    @ApiModelProperty(value = "音频解释")
    private String explanation;

    @ApiModelProperty(value = "流程视频地址")
    @TableField("fd_url")
    private String fdUrl;

    @ApiModelProperty(value = "标清视频地址")
    @TableField("ld_url")
    private String ldUrl;

    @ApiModelProperty(value = "高清程视频地址")
    @TableField("sd_url")
    private String sdUrl;

    @ApiModelProperty(value = "阿里云点播视频id")
    @TableField("video_id")
    private String videoId;

    @ApiModelProperty(value = "逻辑删除字段")
    private Integer deleted=0;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
