package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 营销课程名片配置
 * </p>
 *
 * @author 谢海军123
 * @since 2019-03-07
 */
@Data
@ApiModel(value = "CardConfig", description = "营销课程名片配置")
@TableName("card_config")
public class CardConfig {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "card 名片配置表的唯一id")
	private Long id;

    @ApiModelProperty(value = "企业id")
	@TableField("company_id")
	private Long companyId;

    @ApiModelProperty(value = "站点id")
	@TableField("site_id")
	private Long siteId;

    @ApiModelProperty(value = "配置创建人id")
	@TableField(value = "create_by_id", fill = FieldFill.INSERT)
	private Long createById;

    @ApiModelProperty(value = "配置创建时间")
	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

    @ApiModelProperty(value = "更新人账号id")
	@TableField(value = "update_by_id", fill = FieldFill.UPDATE)
	private Long updateById;

    @ApiModelProperty(value = "更新数据时间")
	@TableField(value = "update_time", fill = FieldFill.UPDATE)
	private Date updateTime;

    @ApiModelProperty(value = "名片上部是否显示，0(false):不显示；1(true):显示")
	@TableField("card_top_display")
	private Boolean cardTopDisplay;

    @ApiModelProperty(value = "上部横幅内容文字")
	@TableField("top_bar_text")
	private String topBarText;

    @ApiModelProperty(value = "上部横幅的背景色")
	@TableField("top_bar_bgColor")
	private String topBarBgcolor;

    @ApiModelProperty(value = "上部横幅显示的按钮 0：显示电话和邮箱；1显示电话；2显示邮箱；3不显示按钮")
	@TableField("top_bar_button")
	private Integer topBarButton;

    @ApiModelProperty(value = "名片中间主体区域显示，0(false):不显示；1(true):显示")
	@TableField("card_body_display")
	private Boolean cardBodyDisplay;

    @ApiModelProperty(value = "中间主体内容_字段1(目前设计为强制显示姓名)  默认为true，显示")
	@TableField("body_field1")
	private Boolean bodyField1;

    @ApiModelProperty(value = "字段2到字段字段4选择列表；值={0:隐藏该字段；1:职务；2部门；3企业名称；4电话；5邮箱；6备注1；7备注2；8；备注3}")
	@TableField("body_field2")
	private Integer bodyField2;

    @ApiModelProperty(value = "字段2到字段字段4选择列表；值={0:隐藏该字段；1:职务；2部门；3企业名称；4电话；5邮箱；6备注1；7备注2；8；备注3}")
	@TableField("body_field3")
	private Integer bodyField3;

    @ApiModelProperty(value = "字段2到字段字段4选择列表；值={0:隐藏该字段；1:职务；2部门；3企业名称；4电话；5邮箱；6备注1；7备注2；8；备注3}")
	@TableField("body_field4")
	private Integer bodyField4;

	@ApiModelProperty(value = "字段2到字段字段5选择列表；值={0:隐藏该字段；1:职务；2部门；3企业名称；4电话；5邮箱；6备注1；7备注2；8；备注3 9:个人签名}")
	@TableField("body_field5")
	private Integer bodyField5;

	@ApiModelProperty(value = "主体背景类型选择按钮 0:默认背景；1:自定义背景")
	@TableField("body_bgImg_radio")
	private Integer bodyBgimgRadio;

    @ApiModelProperty(value = "主体背景图")
	@TableField("body_bgImg")
	private String bodyBgimg;

    @ApiModelProperty(value = "名片底部展开信息是否显示，0(false):不显示；1(true):显示")
	@TableField("card_foot_display")
	private Boolean cardFootDisplay;

	@ApiModelProperty(value = "修改者名称")
	@TableField(value = "update_by_name", fill = FieldFill.INSERT)
	private String updateByName;

	@ApiModelProperty(value = "创建者名称")
	@TableField(value = "create_by_name", fill = FieldFill.UPDATE)
	private String createByName;

}
