package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 课程章节
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
@Data
@Api(tags = "Chapter", description = "课程章节")
@TableName("chapter")
public class Chapter extends Model<Chapter> {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "章节父id")
    @TableField("parent_id")
    private Long parentId;

    @ApiModelProperty(value = "课程")
    @TableField("course_id")
    private Long courseId;

    @ApiModelProperty(value = "层级")
    private Integer layer;

    @ApiModelProperty(value = "章节名称")
    private String name;

    @ApiModelProperty(value = "素材id")
    @TableField("material_id")
    private Long materialId;

    @ApiModelProperty(value = "素材名称")
    @TableField("material_name")
    private String materialName;

    @ApiModelProperty(value = "素材类型1音频 2 视频 3 文本 4 富媒体 5 Scrom (7 过程测验，8总结性测验 ,9 直播")
    @TableField("material_type")
    private Integer materialType;

    @ApiModelProperty(value = "可以获得积分")
    private Integer score;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "排序")
    private Integer sort;

    @ApiModelProperty(value = "父子关系排序")
    private String path;

    @ApiModelProperty("来源类型1 素材 2 考试 9: 测验")
    private Integer source;

    @ApiModelProperty(value = "素材编码")
    @TableField("material_code")
    private String materialCode;

    @ApiModelProperty(value = "复制前章节的id")
    @TableField("chapter_before_id")
    private Long chapterBeforeId;

    @ApiModelProperty(value = "复制标志")
    @TableField("index_id")
    private Long indexId;

    @ApiModelProperty(value = "完成状态0 未完成 1 已完成")
    @TableField(exist = false)
    private Integer overed;

    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @TableField(value = "update_by_id", fill = FieldFill.UPDATE)
    private Long updateById;

    @TableField(value = "update_time", fill = FieldFill.UPDATE)
    private Date updateTime;



    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
