package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 * 分类组和分类的关联信息表
 * </p>
 *
 * @author xiehaijun
 * @since 2019-12-13
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("classify_group")
@ApiModel(value="ClassifyGroup对象", description="分类组和分类的关联信息表")
public class ClassifyGroup implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "分类和组关联id")
    @TableId("id")
    private Long id;

    @ApiModelProperty(value = "分类id")
    @TableField("classify_id")
    private Long classifyId;

    @ApiModelProperty(value = "分类层级")
    @TableField("layer")
    private Integer layer;

    @ApiModelProperty(value = "分类组的唯一id")
    @TableField("classify_group_info_id")
    private Long classifyGroupInfoId;


}
