package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 课程分类组基本信息表
 * </p>
 *
 * @author xiehaijun
 * @since 2019-12-13
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("classify_group_info")
@ApiModel(value="ClassifyGroupInfo对象", description="课程分类组基本信息表")
public class ClassifyGroupInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "主键")
    @TableId("id")
    private Long id;

    @ApiModelProperty(value = "分类组名称")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "分类描述")
    @TableField("desc")
    private String desc;

    @ApiModelProperty(value = "模版类型（1 平铺；2 两级分类；3 三级分类")
    @TableField("template_type")
    private Integer templateType;

    @ApiModelProperty(value = "模版子类型（模版类型=2时候，该值1为一级二级分类，2 为二级分类三级分类）")
    @TableField("template_sub_type")
    private Integer templateSubType;

    @ApiModelProperty(value = "其他字段")
    @TableField("othen")
    private String othen;

    @ApiModelProperty(value = "创建时间")
    @TableField("create_time")
    private Date createTime;

    @ApiModelProperty(value = "创建用户")
    @TableField("create_by_id")
    private Long createById;

    @ApiModelProperty(value = "更新时间")
    @TableField("update_time")
    private Date updateTime;

    @ApiModelProperty(value = "更新用户id")
    @TableField("update_by_id")
    private Long updateById;

    @ApiModelProperty(value = "企业id")
    @TableField("company_id")
    private Long companyId;

    @ApiModelProperty(value = "站点id")
    @TableField("site_id")
    private Long siteId;

    @ApiModelProperty(value = "组织id")
    @TableField("org_id")
    private Long orgId;

    @ApiModelProperty(value = "状态信息 -1 为草稿状态，0 下架状态，1为上架状态(最后一页保存的时候传入1，下一步保存的时候不要存)")
    @TableField("status")
    private Integer status;

    @ApiModelProperty(value = "0表示未删除，1表示删除 ")
    @TableField("deleted")
    private Boolean deleted;


}
