package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import com.yizhi.util.application.sensitive.annotation.SensitiveWords;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 评论
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
@Data
@Api(tags = "Comment", description = "评论")
@TableName("comment")
public class Comment extends Model<Comment> {

    private static final long serialVersionUID = 1L;


    private Long id;

    @ApiModelProperty(value = "账号id")
    @TableField("account_id")
    private Long accountId;

    @ApiModelProperty(value = "评论人")
    private String commentator;

    @SensitiveWords
    @ApiModelProperty(value = "评论内容")
    private String content;

    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "审核状态")
    private Integer deleted;

    @ApiModelProperty(value = "课程id")
    @TableField("course_id")
    private Long courseId;

    @ApiModelProperty(value = "课程名称")
    @TableField("course_name")
    private String courseName;

    @ApiModelProperty(value = "审核备注")
    private String rmark;

    @ApiModelProperty(value = "用户头像")
    @TableField("user_avatar")
    private String  userAvatar;

    @ApiModelProperty(value = "课程状态")
    @TableField("status")
    private Integer  status;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
