package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableLogic;
import com.baomidou.mybatisplus.annotations.TableName;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * <p>
 * 课程指定用户
 * </p>
 *
 * @author 谢海军
 * @since 2018-04-08
 */
@Data
@Api(tags = "CourseAccount", description = "课程指定用户")
@TableName("course_account")
public class CourseAccount extends Model<CourseAccount> {

    private static final long serialVersionUID = 1L;


    private Long id;

    @TableField("relation_id")
    private Long relationId;

    @TableField("name")
    private String name;

    @TableField("course_id")
    private Long courseId;

    @ApiModelProperty(value = "1.部门，2.用户，3.用户组")
    private Integer type;

    @TableField("site_id")
    private Long siteId;

    @TableLogic
    private Integer deleted;

    @ApiModelProperty(value = "用户名")
    @TableField(exist = false)
    private String fullName;

    @ApiModelProperty(value = "工号")
    @TableField(exist = false)
    private String workNum;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
