package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 课程学时发放
 * </p>
 *
 * @author 谢海军123
 * @since 2019-05-14
 */
@Data
@ApiModel(value = "CourseStudyHourDetailed", description = "课程学时发放")
@TableName("course_study_hour_detailed")
public class CourseStudyHourDetailed {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键")
	private Long id;

    @ApiModelProperty(value = "企业id")
	@TableField("company_id")
	private Long companyId;

    @ApiModelProperty(value = "组织id")
	@TableField("org_id")
	private Long orgId;

    @ApiModelProperty(value = "站点id")
	@TableField("site_id")
	private Long siteId;

    @ApiModelProperty(value = "用户id")
	@TableField("account_id")
	private Long accountId;

    @ApiModelProperty(value = "课程id")
	@TableField("course_id")
	private Long courseId;

    @ApiModelProperty(value = "获取的学时")
	@TableField("total_duration")
	private Float totalDuration;

    @ApiModelProperty(value = "获取学时时间")
	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

	@ApiModelProperty(value = "关键字")
	@TableField(value = "key_word")
	private String keyWord;


}
