package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 学习记录
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
@Data
@Api(tags = "Recorde", description = "学习记录")
@TableName("recorde")
public class Recorde extends Model<Recorde> {

    private static final long serialVersionUID = 1L;


    private Long id;

    @ApiModelProperty(value = "账号id")
    @TableField("account_id")
    private Long accountId;

    @ApiModelProperty(value = "课程")
    @TableField("course_id")
    private Long courseId;

    @ApiModelProperty(value = "章节id")
    @TableField("chapter_id")
    private Long chapterId;

    @ApiModelProperty(value = "学习开始时间")
    @TableField("start_time")
    private Date startTime;

    @ApiModelProperty(value = "学习结束时间")
    @TableField("end_time")
    private Date endTime;

    @ApiModelProperty(value = "学习时长")
    private Integer duration;

    @ApiModelProperty(value = "零时学习时长")
    @TableField(exist = false)
    private Integer durationTmp;

    @ApiModelProperty(value = "完成状态0 未完成 1 已完成")
    private Integer overed;

    @ApiModelProperty(value = "退出方式（1正常退出，2异常退出，3超时退出）")
    private Integer exitstates;

    @ApiModelProperty(value = "学习记录是否有效(0 无效 1 有效)")
    private Integer valid;

    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @TableField("org_id")
    private Long orgId;

    @TableField("company_id")
    private Long companyId;

    @TableField("site_id")
    private Long siteId;

    @ApiModelProperty(value = "终端类型")
    @TableField("terminal_type")
    private String terminalType;

    @ApiModelProperty(value = "终端规格")
    @TableField("terminal_device")
    private String terminalDevice;

    @ApiModelProperty(value = "会话id")
    @TableField("session_id")
    private String sessionId;

    @ApiModelProperty(value = "数据类型：1：点击章节开始学习（用来标记最后一次学习）")
    @TableField("data_type")
    private Integer dataType;

    @ApiModelProperty(value = "断点续播的进度点")
    @TableField(exist = false)
    private Integer progress;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
