package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import com.yizhi.util.application.sensitive.annotation.SensitiveWords;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 评论
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
@Data
@Api(tags = "Reply", description = "评论")
@TableName("reply")
public class Reply extends Model<Reply> {

    private static final long serialVersionUID = 1L;


    private Long id;

    @ApiModelProperty(value = "账号id")
    @TableField("account_id")
    private Long accountId;

    @ApiModelProperty(value = "回复人")
    private String replier;
    
    @ApiModelProperty(value = "回复人姓名")
    @TableField("replier_name")
    private String replierName;

    @SensitiveWords
    @ApiModelProperty(value = "回复内容")
    private String content;

    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "审核状态")
    private Integer deleted;

    @ApiModelProperty(value = "课程id")
    @TableField("course_id")
    private Long courseId;

    @ApiModelProperty(value = "课程名称")
    @TableField("course_name")
    private String courseName;

    @ApiModelProperty(value = "评论id")
    @TableField("comment_id")
    private Long commentId;

    @ApiModelProperty(value = "审核备注")
    private String rmark;

    @ApiModelProperty(value = "用户头像")
    @TableField(exist = false)
    private String  userAvatar;

    @ApiModelProperty(value = "回复用户父id")
    @TableField("parent_account_id")
    private Long parentAccountId;

    @ApiModelProperty("回复用户父姓名")
    @TableField("parent_account_fullName")
    private String parentAccountFullName;

    @ApiModelProperty(value = "回复用户父账号名称")
    @TableField("parent_account_name")
    private String parentAccountName;

    @ApiModelProperty("评论回复父Id(若无默认为0)")
    @TableField("reply_parent_id")
    private Long replyParentId;

    @ApiModelProperty("状态(0：上架|1：下架  默认为0)")
    @TableField("status")
    private Integer status;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
