package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * <p>
 * 课程富媒体保存
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
@Data
@Api(tags = "RichMedia", description = "课程富媒体保存")
@TableName("rich_media")
public class RichMedia extends Model<RichMedia> {

    private static final long serialVersionUID = 1L;


    private Long id;

    @ApiModelProperty(value = "素材id")
    @TableField("material_id")
    private Long materialId;

    @ApiModelProperty(value = "富文本内容")
    private String content;

    @ApiModelProperty(value = "富文本标题")
    private String title;

    @ApiModelProperty(value = "作者")
    private String author;

    @ApiModelProperty(value = "logo上传的地址")
    private String logo;

    @ApiModelProperty(value = "逻辑删除字段")
    private Integer deleted=0;
    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
