package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * scorm 课程包解析保存
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
@Data
@Api(tags = "Scorm", description = "scorm 课程包解析保存")
@TableName("scorm")
public class Scorm extends Model<Scorm> {

    private static final long serialVersionUID = 1L;


	private String name;

	@TableField("organization_title")
	private String organizationTitle;

	@TableField("organization_identifier")
	private String organizationIdentifier;

	@TableField("organization_structure")
	private String organizationStructure;

	@TableField("organization_item_title")
	private String organizationItemTitle;

	@TableField("organization_item_identifier")
	private String organizationItemIdentifier;

	@TableField("organization_item_identifierref")
	private String organizationItemIdentifierref;

	@TableField("resource_identifier")
	private String resourceIdentifier;

	@TableField("resource_href")
	private String resourceHref;

	@TableField("resource_files")
	private String resourceFiles;

	private Integer enabled;

	@TableField(value = "create_by_id", fill = FieldFill.INSERT)
	private Long createById;

	@TableField(value = "create_by_name", fill = FieldFill.INSERT)
	private String createByName;

	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

	@TableField(value = "update_by_id", fill = FieldFill.INSERT)
	private Long updateById;

	@TableField(value = "update_by_name", fill = FieldFill.INSERT)
	private String updateByName;

	@TableField(value = "update_time", fill = FieldFill.INSERT)
	private Date updateTime;

@ApiModelProperty(value = "素材id")
	@TableField("material_id")
	private Long materialId;

	private Long id;
	@ApiModelProperty(value = "逻辑删除字段")
	private Integer deleted=0;

	@Override
	protected Serializable pkVal() {
		return this.id;
	}

}
