package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 学员学习记录
 * </p>
 *
 * @author fulan123
 * @since 2018-11-07
 */
@Data
@Api(tags = "StatisticsCourseLearn", description = "学员学习记录")
@TableName("statistics_course_learn")
public class StatisticsCourseLearn extends Model<StatisticsCourseLearn> {

    private static final long serialVersionUID = 1L;


@ApiModelProperty(value = "主键")
	@TableId(value="id", type= IdType.AUTO)
	private Long id;

@ApiModelProperty(value = "课程id")
	@TableField("course_id")
	private Long courseId;

@ApiModelProperty(value = "用户Id")
	@TableField("account_id")
	private Long accountId;

@ApiModelProperty(value = "学习时长（每天学习这门课程已经花费的时间，SUM求和）")
	@TableField("learn_duration")
	private Integer learnDuration;

@ApiModelProperty(value = "学习开始时间，MIN取首次开始时间")
	@TableField("start_time")
	private Date startTime;

@ApiModelProperty(value = "学习结束时间")
	@TableField("end_time")
	private Date endTime;

@ApiModelProperty(value = "last_learn_time字段修改了学习完成时间(learn_state=2完成学习后更新，如有多条记录只更新最后一条,MAX取值）)")
	@TableField("finish_learn_time")
	private Date finishLearnTime;

@ApiModelProperty(value = "0未学习 1进行中 2已完成，MAX取值")
	@TableField("learn_state")
	private Integer learnState;

@ApiModelProperty(value = "首次完成时间(记录第一次完成课程的时间，多条记录只能更新最后一个，MIN取值)")
	@TableField("first_finish_time")
	private Date firstFinishTime;

@ApiModelProperty(value = "可学课程状态（0不可学习 1可学习）")
	@TableField("can_state")
	private Integer canState;

@ApiModelProperty(value = "参加课程状态（0未参加 1已参加）")
	@TableField("join_state")
	private Integer joinState;

@ApiModelProperty(value = "学习次数")
	@TableField("learn_count")
	private Integer learnCount;

@ApiModelProperty(value = "评分状态，如果这个人当天对于这门课程评论了则记为1")
	@TableField("comment_account_count")
	private Integer commentAccountCount;

@ApiModelProperty(value = "当天这个人对于这门课程的评论数，SUM")
	@TableField("comment_count")
	private Integer commentCount;

@ApiModelProperty(value = "课程评分，Max")
	private BigDecimal grade;

@ApiModelProperty(value = "完成课程数状态，课程完成(learn_state=2)时更新为1")
	@TableField("finish_count")
	private Integer finishCount;

@ApiModelProperty(value = "获取积分")
	@TableField("learn_point")
	private Integer learnPoint;

@ApiModelProperty(value = "获取得分")
	@TableField("learn_score")
	private Integer learnScore;

@ApiModelProperty(value = "记录创建时间")
	@TableField("record_create_time")
	private Date recordCreateTime;


	@Override
	protected Serializable pkVal() {
		return this.id;
	}

}
