package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 测验信息表
 * </p>
 *
 * @author 谢海军
 * @since 2018-10-11
 */
@Data
@ApiModel(value = "TestInfo", description = "测验信息表")
@TableName("test")
public class TestInfo {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "测验信息id")
	private Long id;

    @ApiModelProperty(value = "测验名称")
	private String name;

    @ApiModelProperty(value = "测验编码")
	private String code;

    @ApiModelProperty(value = "测验简介")
	private String desc;

    @ApiModelProperty(value = "测验类型：01 过程性测验；02 总结性测验")
	private String type;

    @ApiModelProperty(value = "使用状态：0 草稿；1 使用中；2 未使用； ")
	private Integer status;

    @ApiModelProperty(value = "创建时间")
	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

    @ApiModelProperty(value = "创建人id")
	@TableField(value = "create_by_id", fill = FieldFill.INSERT)
	private Long createById;

    @ApiModelProperty(value = "创建人登陆名")
	@TableField(value = "create_by_name", fill = FieldFill.INSERT)
	private String createByName;

    @ApiModelProperty(value = "更新时间")
	@TableField(value = "update_time", fill = FieldFill.UPDATE)
	private Date updateTime;

    @ApiModelProperty(value = "更新人id")
	@TableField(value = "update_by_id", fill = FieldFill.UPDATE)
	private Long updateById;

    @ApiModelProperty(value = "更新人登陆名")
	@TableField(value = "update_by_name", fill = FieldFill.UPDATE)
	private String updateByName;

    @ApiModelProperty(value = "合格分数")
	@TableField("passing_score")
	private Integer passingScore;

    @ApiModelProperty(value = "测验策略-题目随机：false [0 表示不随机]，true [1表示随机]")
	@TableField("subject_random_strategy")
	private Boolean subjectRandomStrategy;

    @ApiModelProperty(value = "测验策略-选项随机：0 表示不随机，1表示随机")
	@TableField("option_random_strategy")
	private Boolean optionRandomStrategy;

    @ApiModelProperty(value = "测验策略-解析反馈(总结性测试)：0 表示不反馈，1表示反馈")
	@TableField("explain_feedback_strategy")
	private Boolean explainFeedbackStrategy;

    @ApiModelProperty(value = "测验策略-正误反馈(总结性测试)：0 表示不反馈，1表示反馈")
	@TableField("result_feedback_strategy")
	private Boolean resultFeedbackStrategy;

    @ApiModelProperty(value = "测验策略-答案反馈(总结性测试)：0 表示不反馈，1表示反馈")
	@TableField("answer_feedback_strategy")
	private Boolean answerFeedbackStrategy;

    @ApiModelProperty(value = "企业id")
	@TableField("company_id")
	private Long companyId;

    @ApiModelProperty(value = "站点id")
	@TableField("site_id")
	private Long siteId;

    @ApiModelProperty(value = "组织id")
	@TableField("org_id")
	private Long orgId;

	@ApiModelProperty(value = "是否删除")
    private Boolean deleted;

	@ApiModelProperty(value = "测验策略-通过性设置(过程测验)：0 表示答对才能下一题，1表示提交不管对错都能进行下一题")
	@TableField("passed_setting")
	private Boolean passedSetting;

	@ApiModelProperty(value = "关键字,逗号分隔")
	@TableField("keywords")
	private String keywords;

}
