package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 测验试题
 * </p>
 *
 * @author 谢海军123
 * @since 2018-10-11
 */
@Data
@ApiModel(value = "TestSubject", description = "测验试题")
@TableName("test_subject")
public class TestSubject {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "测验试题id")
	private Long id;

    @ApiModelProperty(value = "题型：01 单选题；02 多选题；03 判断题")
	private String type;

    @ApiModelProperty(value = "题干")
	private String questions;

    @ApiModelProperty(value = "图片（此图片为题干相关图片 ，非必填项。）")
	private String img;

    @ApiModelProperty(value = "解析")
	private String explain;

    @ApiModelProperty(value = "分数")
	private Integer score;

    @ApiModelProperty(value = "测验id")
	@TableField("test_id")
	private Long testId;

    @ApiModelProperty(value = "序号，对题目进行排序")
	private Integer sort;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "创建人id")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(value = "创建人登陆名")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(value = "更新时间")
    @TableField(value = "update_time", fill = FieldFill.UPDATE)
    private Date updateTime;

    @ApiModelProperty(value = "更新人id")
    @TableField(value = "update_by_id", fill = FieldFill.UPDATE)
    private Long updateById;

    @ApiModelProperty(value = "更新人登陆名")
    @TableField(value = "update_by_name", fill = FieldFill.UPDATE)
    private String updateByName;



}
