package com.yizhi.course.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

@Data
@Api(tags = "viewCourseCount", description = "浏览课程的人次")
@TableName("course_view_record")
public class ViewCourseCount extends Model<ViewCourseCount> {

    private static final long serialVersionUID = 1L;

    private Long id;

    @ApiModelProperty(value = "课程id")
    @TableField("course_id")
    private Long courseId;

    @ApiModelProperty(value = "用户id")
    @TableField("account_id")
    private Long accountId;

    @ApiModelProperty(value = "企业id")
    @TableField("company_id")
    private Long companyId;

    @ApiModelProperty(value = "组织id")
    @TableField("org_id")
    private Long orgId;

    @ApiModelProperty(value = "站点id")
    @TableField("site_id")
    private Long siteId;

    @TableField(value = "time", fill = FieldFill.INSERT)
    private Date time;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }
}
