package com.yizhi.course.application.mapper;


import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.course.application.domain.Accredit;
import com.yizhi.course.application.domain.Course;
import com.yizhi.course.application.vo.AuthorizeCourseVO;
import com.yizhi.course.application.vo.AuthorizedCourseVO;
import org.apache.ibatis.annotations.Param;
import java.util.List;
import org.apache.ibatis.session.RowBounds;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author fulan123
 * @since 2018-04-25
 */
public interface AccreditMapper extends BaseMapper<Accredit> {



	Integer getCourseListCount(@Param(value = "name") String name, @Param(value = "companyId") Long companyId,
			@Param(value = "siteId") Long siteId);

	List<Course> courseList(@Param(value = "name") String name, @Param(value = "companyId") Long companyId,
                            @Param(value = "siteId") Long siteId, RowBounds rowBounds);
	

	Integer getNoCourseListCount(@Param(value = "name") String name, @Param(value = "companyId") Long companyId,
			@Param(value = "siteId") Long siteId);

	List<Course> noCourseList(@Param(value = "name") String name, @Param(value = "companyId") Long companyId,
			@Param(value = "siteId") Long siteId, RowBounds rowBounds);
	
	
	List<Course> YXcourseList(@Param(value = "name") String name, @Param(value = "companyId") Long companyId,
			@Param(value = "siteId") Long siteId);

    /**
     * 根据课程名查询授权列表
     * @param siteName 站点名称
     * @param companyName 公司名称
     * @Author lilingye
     * @return
     */
	List<AuthorizeCourseVO> queryAuthorizeCourse(@Param(value = "type") String type,
                                                 @Param(value = "siteName") String siteName,
                                                 @Param(value = "companyName") String companyName,
                                                 @Param(value = "siteId") Long siteId,
                                                 RowBounds rowBounds
    );

    List<AuthorizeCourseVO> queryAuthorizeCourse(
            Page<AuthorizeCourseVO> page,
            @Param(value = "type") String type,
                                                 @Param(value = "siteName") String siteName,
                                                 @Param(value = "companyName") String companyName,
                                                 @Param(value = "siteId") Long siteId
    );

    /**
     * 查询授权或销售课程列表
     * @param type
     * @param siteName 站点名
     * @param companyName 公司名称
     * @return
     */
    List<AuthorizeCourseVO> queryAuthorizeCount(@Param(value = "type") String type,
                                                @Param(value = "siteName") String siteName,
                                                @Param(value = "companyName") String companyName,
                                                @Param(value = "siteId") Long siteId
    );


    List<AuthorizedCourseVO> getAuthorizedList(@Param(value = "courseKeys") String courseKeys,
                                               @Param(value = "startTime") String startTime,
                                               @Param(value = "endTime") String endTime,
                                               @Param(value = "siteId") Long siteId,
                                               @Param(value = "activeType") Integer activeType,
                                               @Param(value = "type") Integer type,
                                               @Param(value = "sourceSiteId") Long sourceSiteId,
                                               RowBounds rowBounds);

    Integer getAuthorizedCount(@Param(value = "courseKeys") String courseKeys,
                                               @Param(value = "startTime") String startTime,
                                               @Param(value = "endTime") String endTime,
                                                @Param(value = "siteId") Long siteId,
                                                @Param(value = "activeType") Integer activeType,
                                               @Param(value = "type") Integer type,
                                               @Param(value = "sourceSiteId") Long sourceSiteId);

    List<AuthorizedCourseVO> getAuthorizeList(@Param(value = "classifyId") Long classfyId,
                                              @Param(value = "siteId") Long siteId,
                                              @Param(value = "name") String name,
                                              @Param(value = "sourceSiteId") Long sourceSiteId,
                                              RowBounds rowBounds);

    // 总共条数
    Integer getAuthorizeListCount(@Param(value = "classifyId") Long classfyId,
                                  @Param(value = "siteId") Long siteId,
                                  @Param(value = "name") String name,
                                  @Param(value = "sourceSiteId") Long sourceSiteId
                                  );
}

