package com.yizhi.course.application.mapper;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.course.application.domain.CourseStudyHour;
import com.yizhi.course.application.vo.MyDurationVO;
import com.yizhi.course.application.vo.StudyHourReportVO;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 * 课程学时发放明细 Mapper 接口
 * </p>
 *
 * @author 谢海军123
 * @since 2019-05-14
 */
public interface CourseStudyHourMapper extends BaseMapper<CourseStudyHour> {

    @Select("<script>" +
            " SELECT SUM(total_duration) FROM course_study_hour" +
            " WHERE 1=1" +
            " <if test='siteId != null'>" +
            " AND site_id = #{siteId} " +
            " </if>" +
            " <if test='accountId != null'>" +
            " AND account_id = #{accountId} " +
            " </if>" +
            " <if test='courseId != null'>" +
            " AND course_id = #{courseId} " +
            " </if>" +
            "</script>")
    Float studyHourSum(@Param("siteId") Long siteId,
                       @Param("accountId") Long accountId,
                       @Param("courseId") Long courseId);

    /**
     * 学时统计获取列表
     * @param companyId
     * @param siteId
     * @param accountIds
     * @return
     */
    List<StudyHourReportVO> getStudyHourList(@Param("companyId") Long companyId,
                                             @Param("siteId") Long siteId,
                                             @Param("accountIds") List<Long> accountIds);

    List<MyDurationVO> queryDurationByAccountId(@Param("accountId") Long accountId, @Param("siteId") Long siteId, Page page);

    Integer queryDurationByAccountIdNum(@Param("accountId") Long accountId, @Param("siteId") Long siteId);

    /**
     * 学时明细下载
     * @param companyId
     * @param siteId
     * @param accountIds
     * @return
     */
    List<StudyHourReportVO> getStudyHourDetails(@Param("companyId") Long companyId,
                                                @Param("siteId") Long siteId,
                                                @Param("accountIds") List<Long> accountIds);
}
