package com.yizhi.course.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.course.application.domain.Favorite;
import com.yizhi.course.application.vo.ApiListCourseVo;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.session.RowBounds;

import java.util.List;

/**
 * <p>
 * 课程收藏 Mapper 接口
 * </p>
 *
 * @author fulan123
 * @since 2018-04-23
 */
public interface FavoriteMapper extends BaseMapper<Favorite> {

    Integer selectMyCourseCount(@Param("accountId")Long accountId,@Param("companyId") Long companyId, @Param("siteId")Long siteId);


    List<ApiListCourseVo> selectMyCourseList(@Param("name") String name, @Param("accountId")Long accountId,
                                             @Param("companyId") Long companyId, @Param("siteId")Long siteId,
                                             RowBounds rowBounds);

    /**
     *  ( PC端) 我的课程收藏列表(分页)
     *
     * @param name
     * @param accountId
     * @param companyId
     * @param siteId
     * @param rowBounds
     * @return
     */
    List<ApiListCourseVo> selectPCMyCourseList(@Param("name") String name,@Param("accountId")Long accountId,
                                               @Param("companyId") Long companyId, @Param("siteId")Long siteId,
                                               RowBounds rowBounds);

    Integer selectPCMyCourseListCount(@Param("name") String name,@Param("accountId")Long accountId,
                                               @Param("companyId") Long companyId, @Param("siteId")Long siteId);

}
