package com.yizhi.course.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.course.application.domain.OfflineClassify;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.session.RowBounds;

import java.util.List;

/**
 * <p>
 * 线下课程分类 Mapper 接口
 * </p>
 *
 * @author huangliang123
 * @since 2018-10-16
 */
public interface OfflineClassifyMapper extends BaseMapper<OfflineClassify> {
    /**
     * 查找这个父级分类下的最大排序数
     *
     * @param parentId
     * @return
     */
    int selectSort(@Param("ParentId") Long parentId);

    /**
     * 根据id查找层级
     *
     * @param id
     * @return
     */
    Integer selectParentLayer(@Param("id") Long id);

    /**
     * 根据id查找root_id
     *
     * @param id
     * @return
     */
    Long selectRootId(@Param("id") Long id);

    /**
     * 根据companyId查询列表信息(分页查询)
     *
     * @param companyId
     * @param name
     * @param orgIds
     * @param siteId
     * @param rowBounds
     * @return
     */
    List<OfflineClassify> selectListByCompanyId(@Param("companyId")Long companyId,
                                                  @Param("name")String name,
                                                  @Param("orgIds")List<Long> orgIds,
                                                  @Param("siteId")Long siteId,
                                                  RowBounds rowBounds);

    /**
     * 查询数量
     *
     * @param companyId
     * @param name
     * @param orgIds
     * @param siteId
     * @return
     */
    Integer selectCountByCompanyId(@Param("companyId") Long companyId,
                                   @Param("name") String name,
                                   @Param("orgIds") List<Long> orgIds,
                                   @Param("siteId") Long siteId);

    /**
     * 查询层级分类
     *
     * @param companyId
     * @param siteId
     * @param layer
     * @return
     */
    List<OfflineClassify> selectOfflineClassifyByLayer(@Param("companyId") Long companyId, @Param("siteId") Long siteId, @Param("layer") Integer layer);
}
