package com.yizhi.course.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.course.application.domain.OfflineCourse;
import com.yizhi.course.application.vo.ReportOfflineCourseStatisticsDetailVo;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.session.RowBounds;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 线下课程表 Mapper 接口
 * </p>
 *
 * @author huangliang123
 * @since 2018-10-16
 */
public interface OfflineCourseMapper extends BaseMapper<OfflineCourse> {

    /**
     * 验证线下课程code唯一性
     *
     * @param id
     * @param code
     * @param siteId
     * @return
     */
    Integer verifyCourseCode(@Param(value = "id") Long id,@Param(value = "code") String code,@Param(value = "siteId") Long siteId);

    /**
     * 线下课程分页查询
     *
     * @param name
     * @param offlineClassifyId
     * @param status
     * @param companyId
     * @param siteId
     * @param orgIds
     * @param rowBounds
     * @return
     */
    List<OfflineCourse> searchPage(@Param(value = "name") String name, @Param(value = "offlineClassifyId") Long offlineClassifyId, @Param(value = "status") Integer status,
                                   @Param(value = "companyId") Long companyId, @Param(value = "siteId") Long siteId, @Param("orgIds") List<Long> orgIds, @Param("offline_courseIds") List<Long> offline_courseIds, RowBounds rowBounds);

    /**
     * 线下课程分页总数量查询
     *
     * @param name
     * @param offlineClassifyId
     * @param status
     * @param companyId
     * @param siteId
     * @param orgIds
     * @return
     */
    Integer searchPageCount(@Param(value = "name") String name, @Param(value = "offlineClassifyId") Long offlineClassifyId, @Param(value = "status") Integer status,
                            @Param(value = "companyId") Long companyId, @Param(value = "siteId") Long siteId, @Param("orgIds") List<Long> orgIds,@Param("offline_courseIds") List<Long> offline_courseIds);

    /**
     * 全文检索
     *
     * @param name
     * @param companyId
     * @param siteId
     * @param orgId
     * @return
     */
    List<OfflineCourse> selectCourseList(@Param(value = "name") String name, @Param(value = "companyId") Long companyId,
                                         @Param(value = "siteId") Long siteId, @Param(value = "orgId") Long orgId);

    /**
     * 报表统计详情
     *
     * @param startTime
     * @param endTime
     * @return
     */
    List<ReportOfflineCourseStatisticsDetailVo> statisticsDetail(@Param("startTime") Date startTime, @Param("endTime") Date endTime,
                                                                 @Param("code") String code, @Param("name") String name,
                                                                 @Param("context") RequestContext context, RowBounds rowBounds);

    /**
     * 报表统计详情
     *
     * @param startTime
     * @param endTime
     * @return
     */
    Integer statisticsDetailCount(@Param("startTime") Date startTime, @Param("endTime") Date endTime,
                                  @Param("code") String code, @Param("name") String name,
                                  @Param("context") RequestContext context);
}
