package com.yizhi.course.application.mapper;

import java.util.Date;
import java.util.List;

import com.yizhi.course.application.domain.ScormRecord;
import com.yizhi.course.application.vo.StatisticsCourseRecorde;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.mapper.BaseMapper;

/**
 * <p>
 * Scorm 学习记录 Mapper 接口
 * </p>
 *
 * @author shengchenglong123
 * @since 2018-10-31
 */
public interface ScormRecordMapper extends BaseMapper<ScormRecord> {


	@Select("<script>" +
			"SELECT id, scorm_id AS scormId, chapter_id AS chapterId, account_id AS accountId, `data`, finished, deleted, score," +
			" total_study_seconds AS totalStudySeconds, create_time AS createTime, update_time AS updateTime, site_id AS siteId," +
			" company_id AS companyId, current_study_seconds AS currentStudySeconds, start_study_time AS startStudyTime, terminal_type AS" +
			" terminalType FROM scorm_record WHERE scorm_id = #{scormId} AND" +
			" account_id = #{accountId} AND site_id = #{siteId} AND company_id = #{companyId} " +
			" AND start_study_time = #{scormStartTime}" +
			"</script>")
	ScormRecord findExtisRecord(@Param("accountId") Long accountId,
								@Param("companyId") Long companyId,
								@Param("siteId") Long siteId,
								@Param("scormId") Long scormId,
								@Param("scormStartTime") String scormStartTime);
	    
	  Date  minRecordTime();
	  
	  void deleteRecord();
	  
	  
	  List<ScormRecord> selectList111();
	  
	  
	  List<ScormRecord> selectRecord();
	  
	  List<ScormRecord> selectList222(@Param("accountId")Long accountId,@Param("scormId")Long scormId);
	  
	  
	  
	  
	  List<StatisticsCourseRecorde> getScormCourseRecordeByCourseId(@Param("cId") Long cId, @Param("startDate") String startDate, @Param("endDate") String endDate);
   

}
