package com.yizhi.course.application.mapper;

import java.util.List;

import com.yizhi.course.application.domain.CourseStudyHour;
import com.yizhi.course.application.domain.Recorde;
import com.yizhi.course.application.vo.CourseStudyHourVO;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.bind.annotation.GetMapping;

import com.baomidou.mybatisplus.mapper.BaseMapper;

/**
 * <p>
 * Scorm 学习记录 Mapper 接口
 * </p>
 *
 * @author shengchenglong123
 * @since 2018-10-31
 */
public interface ShenWanHongYuanAccountRecordMapper extends BaseMapper<Recorde> {
	
	/**
	 * 按学员课程分组获取学时
	 * @param queryDay
	 * @param courseIds
	 * @param accountIds
	 * @return
	 */
	List<CourseStudyHourVO> getAccountCourseGroupRecorde(@Param("queryDay") Integer queryDay, @Param("courseIds") List<Long> courseIds,
														 @Param("accountIds") List<Long> accountIds);
	
	/**
	 * 按学员分组获取学时
	 * @param queryDay
	 * @param courseIds
	 * @param accountIds
	 * @return
	 */
	List<CourseStudyHourVO> getAccountGroupRecorde(@Param("queryDay") Integer queryDay, @Param("courseIds") List<Long> courseIds,
			@Param("accountIds") List<Long> accountIds);
}
