package com.yizhi.course.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.course.application.domain.TestCase;
import com.yizhi.course.application.vo.TestCaseRecordVO;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 * 测验案件 Mapper 接口
 * </p>
 *
 * @author 谢海军123
 * @since 2018-10-17
 */
public interface TestCaseMapper extends BaseMapper<TestCase> {

    @Select("SELECT MAX(test_score) FROM test_case WHERE test_id=#{testId} " +
            "and course_id=#{courseId} and chapter_id=#{chapterId} and account_id=#{accountId} ")
    Integer selectMaxScore(@Param("courseId") Long courseId, @Param("chapterId") Long chapterId,
                           @Param("testId") Long testId, @Param("accountId") Long accountId);

    @Select("SELECT chapter_id AS testId,MAX(test_score) AS testScore FROM test_case " +
            " WHERE course_id=#{courseId} and account_id= ${accountId} " +
            " GROUP BY chapter_id")
    List<TestCaseRecordVO> selectTestMaxScore(@Param("courseId") Long courseId,
                                              @Param("accountId") Long accountId);

    @Select("SELECT id, test_id AS testId,test_score AS testScore,score AS passingScore,status AS isPass " +
            " FROM test_case " +
            " WHERE test_id = ${testId} AND account_id = ${accountId} " +
            " ORDER BY create_time DESC")
    List<TestCaseRecordVO> chapterTestList(@Param("testId") Long testId,
                                           @Param("accountId") Long accountId);

}
