package com.yizhi.course.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.course.application.domain.TestSubject;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

/**
 * <p>
 * 测验试题 Mapper 接口
 * </p>
 *
 * @author 谢海军123
 * @since 2018-10-11
 */
public interface TestSubjectMapper extends BaseMapper<TestSubject> {

    @Select("SELECT SUM(score) FROM test_subject WHERE test_id=#{testId}")
    Integer sumScore(@Param("testId") Long testId);

    @Select("SELECT IFNULL(MAX(sort),0)+1 FROM test_subject WHERE test_id=#{testId}")
    Integer maxSort(@Param("testId") Long testId);

    @Select("SELECT IFNULL(MIN(sort),0)+1 FROM test_subject WHERE test_id=#{testId}")
    Integer minSort(@Param("testId") Long testId);

    @Update({"update test_subject set sort=sort-1 WHERE test_id=#{testId} AND sort > #{sort} "})
    int updateSort(@Param("testId") Long testId,@Param("sort") Integer sort);

    @Update({"update test_subject set sort=#{upsort} WHERE test_id=#{testId} AND sort = #{sort} "})
    int updateSortByTestId(@Param("testId") Long testId,@Param("sort") Integer sort,@Param("upsort") Integer upsort);

    @Update({"update test_subject set sort=#{sort} WHERE id=#{id}"})
    int updateSortById(@Param("id") Long id,@Param("sort") Integer sort);

}
