package com.yizhi.course.application.service;


import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.application.orm.util.QueryUtil;
import com.yizhi.core.application.task.AbstractTaskHandler;
import com.yizhi.core.application.vo.AuthorizeChapterVO;
import com.yizhi.course.application.controller.CourseController;
import com.yizhi.course.application.domain.Chapter;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

/**
 * @author  lilingye
 * @date  2018-10-25 11:15:23
 */
@Component
@Log4j2
public class ChapterUpdateTask extends AbstractTaskHandler {
    @Autowired
    private IdGenerator idGenerator;

    @Autowired
    private IAccreditService accreditService;

    @Autowired
    private IChapterService chapterService;

    @Autowired
    CourseController courseController;

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void handle() {

        AuthorizeChapterVO chapterVO = this.taskContext.getChapterVO();
        Chapter chapterParam = new Chapter();
        chapterParam.setChapterBeforeId(chapterVO.getId());
        chapterParam.setLayer(chapterVO.getLayer());

        List<Chapter> chapters = chapterService.selectList(QueryUtil.condition(chapterParam));
        List<Chapter> chaptersList = new ArrayList<>();
        List<Chapter> newChapters = chapterService.getChapterList(chaptersList,chapterVO.getId());
        log.info("对象列表是:"+chapters);

        for (Chapter c :newChapters){
                // 修改
                Chapter chapter = new Chapter();
                chapter.setCourseId(c.getCourseId());
                chapter.setId(c.getId());
                chapter.setName(chapterVO.getName());
                chapter.setMaterialId(chapterVO.getMaterialId());
                chapter.setMaterialType(chapterVO.getMaterialType());
                chapter.setMaterialName(chapterVO.getMaterialName());
                chapter.setMaterialCode(chapterVO.getMaterialCode());

                courseController.chapterUpdate(chapter);
        }

    }
}
