package com.yizhi.course.application.service;

import com.baomidou.mybatisplus.service.IService;
import com.yizhi.course.application.domain.CourseStudentStatus;
import com.yizhi.course.application.vo.CourseDashboardParam;
import com.yizhi.course.application.vo.CourseDashboardVO;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * <p>
 * 课程学习状态 服务类
 * </p>
 *
 * @author 谢海军123
 * @since 2019-04-01
 */
public interface ICourseStudentStatusService extends IService<CourseStudentStatus> {

    /**
     * 查找当前用户在该站点有效的学习课程记录
     * @param siteId
     * @param accountId
     * @return
     */
    List<CourseStudentStatus> findValidStudyCourse(Long siteId, Long accountId, Date startDate, Date endDate);

    List<CourseStudentStatus> getTrainningMqInfo();

    /**
     * 获取《用户id,<课程dashboard>》
     * @return
     */

    Map<Long, CourseDashboardVO> getCourseDashboardData(CourseDashboardParam param);

}
