package com.yizhi.course.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.course.application.domain.Favorite;
import com.yizhi.course.application.vo.ApiListCourseVo;
import io.swagger.models.auth.In;
import org.apache.ibatis.session.RowBounds;

import java.util.List;

/**
 * <p>
 * 课程收藏 服务类
 * </p>
 *
 * @author fulan123
 * @since 2018-04-23
 */
public interface IFavoriteService extends IService<Favorite> {

    Integer selectMyCourseCount(Long accountId,Long companyId,Long siteId);


    List<ApiListCourseVo> selectMyCourseList(String name, Long accountId, Long companyId, Long siteId,
                                             Integer pageNo, Integer pageSize);


    /**
     *  ( PC端) 我的课程收藏列表(分页)
     *
     * @param name
     * @param accountId
     * @param companyId
     * @param siteId
     * @param pageNo
     * @param pageSize
     * @return
     */
    Page<ApiListCourseVo> selectPCMyCourseList(String name, Long accountId,Long companyId,Long siteId,
                                               Integer pageNo, Integer pageSize);


}
