package com.yizhi.course.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.course.application.domain.OfflineClassify;
import com.yizhi.course.application.vo.OfflineClassifyVo;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 线下课程分类 服务类
 * </p>
 *
 * @author huangliang123
 * @since 2018-10-16
 */
public interface IOfflineClassifyService extends IService<OfflineClassify> {

    /**
     * 根据id删除线下课程分类
     *  notice: 只能删除没有子分类的实体
     *
     * @param id
     * @return
     */
    Integer deleteById(Long id);

    /**
     * 添加一个新的线下课程分类
     *
     * @param offlineClassify
     * @return
     */
    Integer saveOfflineClassify(OfflineClassify offlineClassify);

    /**
     * 根据分类对象修改线下课程分类
     *
     * @param offlineClassify
     * @return
     */
    Integer updateOfflineClassify(OfflineClassify offlineClassify);

    /**
     *  线下课程分类排序
     *
     * @param list
     * @return
     */
    Integer  offlineClassifySort(List<OfflineClassify> list);

    /**
     * 线下课程分类分页查询
     *
     * @param companyId
     * @param name
     * @param orgIds
     * @param siteId
     * @param pageNo
     * @param pageSize
     * @return
     */
    Page<OfflineClassifyVo> selectListByCompanyId(Long companyId, String name, List<Long> orgIds, Long siteId, Integer pageNo, Integer pageSize);

    /**
     * 根据分类层级查询线下课程分类
     * @param companyId
     * @param siteId
     * @param layer
     * @return
     */
    List<OfflineClassify>selectOfflineClassifyByLayer(Long companyId, Long siteId,Integer layer);

    /**
     * 根据名称查询分类
     *
     * @return
     */
    List<OfflineClassify> listOfflineClassify();

}
