package com.yizhi.course.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.course.application.domain.OfflineRecorde;
import com.yizhi.course.application.vo.ReportOfflineCourseStatisticsDetailVo;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 线下课程学习记录 服务类
 * </p>
 *
 * @author huangliang123
 * @since 2018-10-16
 */
public interface IOfflineRecordeService extends IService<OfflineRecorde> {

    /**
     * 报表数据统计
     *
     * @param startTime
     * @param endTime
     * @param context
     * @return
     */
    List<OfflineRecorde> dataStatistics(Date startTime, Date endTime, RequestContext context);


    /**
     * 报表统计详情
     *
     * @param startTime
     * @param endTime
     * @param pageSize
     * @param pageNo
     * @param context
     * @return
     */
    Page<ReportOfflineCourseStatisticsDetailVo> statisticsDetail(Date startTime, Date endTime, String code, String name,
                                                                 int pageSize, int pageNo, RequestContext context);

    /**
     * 报表统计详情
     *
     * @param startTime
     * @param endTime
     * @param context
     * @return
     */
    List<ReportOfflineCourseStatisticsDetailVo> statisticsDetailExport(Date startTime, Date endTime, String code, String name, RequestContext context);

    /**
     * 获取最后导入的批次
     *
     * @param courseId
     * @param siteId
     * @param companyId
     * @return
     */
    Integer getLastBatch(Long courseId, Long siteId, Long companyId);

    /**
     *   查询报表记录详情
     *
     * @param offlineCourseId
     * @return
     */
    Page<OfflineRecorde> queryDetailByOfflineCourseId(Long offlineCourseId, Integer pageNo, Integer pageSize);
}
