package com.yizhi.course.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.course.application.domain.Recorde;
import com.yizhi.course.application.vo.*;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 学习记录 服务类
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
public interface IRecordeService extends IService<Recorde> {

	/**
	 * 查询站点下学习时长汇总信息
	 * @param siteId
	 * @return
	 */
	List<CourseStudyDurationRanking> studyHourRanking(Long siteId, String active);

	Integer updateByHeart(Long dataId, Integer progress, Date endDate);

    CourseStudyStatisticVO getCourseStudyStatistic(Long courseId,
												   Long accountId, Long siteId);

	List<RecordeListVo> selectRecordeList(Long accountId, Long courseId);

	List<RecordeListVo> selectRecordeOveredList(Long accountId, Long courseId,Long siteId);

	Page<MyCourseRecordeVo> selectMyCourseRecordeList(String name, Long accountId, Integer type, Integer pageNo,
													  Integer pageSize);

	Integer selectDurationByCourseId(Long courseId);

	Integer selectMyCourseRecordeCount(Long accountId, Integer type);

	List<RecordeDurationVO> selectAllRecordeDuration();

	Recorde saveRecorde(List<StudyLog> data);

	long selectLastStudy(Long courseId, Long accountId);

	Long getCourseFinished(Long accountId, Long chapterId);

	List<Long> getFinishedIds(Long courseId);

	/**
	 * 专为培训统计时长所用
	 *
	 * @param courseId
	 * @returngetCourseTotalDuration
	 */
	Integer getStudyTime(List<Long> courseId);

	Long countStudyDuration(Long accountId, Long chapterId, Long siteId);

	Long countStudyDurationCourseIds(Long accountId, Long siteId, List<Long> courseIds);

	/**
	 * 获取学习的全部课程
	 *
	 * @param siteId
	 * @return
	 */
	List<RecordeListVo> findStuByAccountG(Long siteId);

	/**
	 * 获取学习课程的章节的学习信息
	 *
	 * @param siteId
	 * @param courseId
	 * @param accountId
	 * @return
	 */
	List<RecordeVO> findStuChapterByAccountG(Long siteId, Long courseId, Long accountId);

	Integer findRankingNumById(Long siteId, Long accountId);

	List<OrganizationDurationVO> getOrgDuration(Long siteId, Integer top, List<Long> accountIds);
	
	StudyDurationVO studyDuration(Long accountId,List<Long> siteIds,String startDate,String endDate,List<Long> accounts);

	Long todayStudyTime(String startDate, String endDate);

	/**
	 * 返回《用户id，用户累计学习时长S》
	 * @param param
	 * @return
	 */
	Map<Long, Long> getCourseStudyTime(CourseDashboardParam param);

}
