package com.yizhi.course.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.course.application.vo.MarketingCourseViewVo;
import com.yizhi.course.application.vo.ReportMarketingCourseAccountVo;
import com.yizhi.course.application.vo.ReportMarketingCourseDataChartsVo;
import com.yizhi.course.application.vo.ReportMarketingCourseVo;

import java.util.List;

/**
 * @Author: XieHaijun
 * @Description:
 * @Date: Created in 17:16 2018/8/14
 * @Modified By
 */
public interface IReportMkCourseService extends IService<ReportMarketingCourseVo> {

    /**
     * 图表数据获取
     * @param startDate
     * @param endDate
     * @param type
     * @param pageSize
     * @param pageNo
     * @param cid
     * @param siteId
     * @param orgs
     * @return
     */
    Page<ReportMarketingCourseDataChartsVo> chartGroup(String startDate, String endDate, Integer type,
                                                       Integer pageSize, Integer pageNo, Long cid, Long siteId,
                                                       List<Long> orgs);

    /**
     * 根据课程分类查看
     * @param startDate
     * @param endDate
     * @param kwd
     * @param pageSize
     * @param pageNo
     * @param cid
     * @param siteId
     * @param orgs
     * @return
     */
    Page<ReportMarketingCourseVo> marketingCourseGroup(
            String startDate, String endDate, String kwd, Integer pageSize, Integer pageNo,
            Long cid, Long siteId, List<Long> orgs,boolean isPage);

    Page<MarketingCourseViewVo> marketingCourseViewList(Long courseId, String nikeName,
                                                        Integer pageSize, Integer pageNo);


    /**
     * 根据用户查看报表
     * @param startDate
     * @param endDate
     * @param orgKwd
     * @param accountKwd
     * @param pageSize
     * @param pageNo
     * @param cid
     * @param siteId
     * @param orgs
     * @return
     */
    Page<ReportMarketingCourseAccountVo> marketingCourseAccountGroup(String startDate, String endDate,
                                                                     List<Long> orgKwd, List<Long> accountKwd,
                                                                     Integer pageSize, Integer pageNo,
                                                                     Long cid, Long siteId,
                                                                     List<Long> orgs, boolean isPage);

    /**
     * 下载统计
     * @param startDate
     * @param endDate
     * @param orgKwd
     * @param accountKwd
     * @param cid
     * @param siteId
     * @param orgs
     * @param business
     * @return
     */
    List<Object[]> downStatistics(String startDate,String endDate,
                                  List<Long> orgKwd, List<Long> accountKwd,
                                  Long cid, Long siteId,
                                  List<Long> orgs,
                                  String business);
}
