package com.yizhi.course.application.service;

import com.baomidou.mybatisplus.service.IService;
import com.yizhi.course.application.domain.Scorm;
import com.yizhi.course.application.domain.ScormRecord;
import com.yizhi.course.application.vo.ProjectsDurationParamVO;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * scorm 课程包解析保存 服务类
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
public interface IScormService extends IService<Scorm> {

    /**
     * 保存 scorm 记录
     *
     * @param scormRecord
     * @return
     */
    ScormRecord saveScormRecord(ScormRecord scormRecord);

    /**
     * 复旦mini mba项目获取多个培训项目总学习时长
     *
     * @param paramVO
     * @return
     */
    Integer getProjectsTotalDuration(ProjectsDurationParamVO paramVO);

    /**
     * 复旦mini mba项目获取多个个课程的学习总时长
     *
     * @param bizIds
     * @return
     */
    Map<Long, Map<String, Object>> getCourseTotalDuration(List<Long> bizIds);
}
