package com.yizhi.course.application.service;

import com.baomidou.mybatisplus.service.IService;
import com.yizhi.course.application.domain.TestCase;
import com.yizhi.course.application.vo.TestCaseRecordVO;
import com.yizhi.course.application.vo.TestCaseSimpleSubmitVO;
import com.yizhi.course.application.vo.TestCaseSubmitVO;
import com.yizhi.course.application.vo.TestCaseVO;

import java.util.List;

/**
 * <p>
 * 测验案件 服务类
 * </p>
 *
 * @author 谢海军123
 * @since 2018-10-17
 */
public interface ITestCaseService extends IService<TestCase> {

    TestCaseSubmitVO testSubmit(TestCaseVO vo);

    TestCaseRecordVO getRecordInfo(Long testCaseId);

    TestCaseSimpleSubmitVO testCaseSimpleSubmit(TestCaseSimpleSubmitVO vo);

    Integer selectMaxScore(Long courseId, Long chapterId,
                           Long testId, Long accountId);

    // 获取最高分数的测验
    List<TestCaseRecordVO> findMaxTestScore(Long courseId, Long accountId);

    /**
     * 判断该课程是否被该用户测验通过
     *
     * @param courseId
     * @param accountId
     * @return
     */
    Boolean courseIsSucceed(Long courseId, Long accountId);

    List<TestCaseRecordVO> chapterTestList(Long testId,
                                           Long accountId);
}
