package com.yizhi.course.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.course.application.domain.TestInfo;
import com.yizhi.course.application.vo.TestInfoListReqVO;
import com.yizhi.course.application.vo.TestInfoVO;

import java.util.List;

/**
 * <p>
 * 测验表 服务类
 * </p>
 *
 * @author 谢海军123
 * @since 2018-10-11
 */
public interface ITestService extends IService<TestInfo> {

    /**
     * 管理端查询测试信息列表
     * @param reqVO 请求参数
     * @return
     */
    Page<TestInfoVO> listPage(TestInfoListReqVO reqVO);

    /**
     * 根据测验id删除测验数据
     * @param ids
     * @return
     */
    Boolean deleteIds(List<Long> ids);

    /**
     * 保存测验信息
     * @param vo
     * @return
     */
    TestInfoVO saveTest(TestInfoVO vo);

    /**
     * 更新测验是否被使用中
     * @param testId
     * @return
     */
    Boolean updateStatus(Long testId, Long chapterId,Integer type);
}
