package com.yizhi.course.application.service.impl;

import java.util.ArrayList;
import java.util.List;

import com.yizhi.course.application.domain.LessonReply;
import com.yizhi.course.application.domain.Material;
import com.yizhi.course.application.service.ILessonReplyService;
import com.yizhi.course.application.service.IMaterialService;
import com.yizhi.course.application.vo.NoPassReason;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.toolkit.CollectionUtils;
import com.yizhi.course.application.mapper.LessonReplyMapper;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author wangfeida123
 * @since 2018-04-04
 */
@Service
public class LessonReplyServiceImpl extends ServiceImpl<LessonReplyMapper, LessonReply> implements ILessonReplyService {
	
	@Autowired
	private LessonReplyMapper lessonReplyMapper;
	@Autowired
	private IMaterialService materialService;

	@Override
	public List<NoPassReason> getNoPassReason(Long lessonId, Integer pageNo, Integer pageSize) {
		// TODO Auto-generated method stub
		List<NoPassReason> list2=new ArrayList<NoPassReason>();
		//先查看现在的状态
		Material material=materialService.selectById(lessonId);
		if(material!=null) {
			if(material.getState()==3) {
				NoPassReason noPassReason=new NoPassReason();
				noPassReason.setId(material.getId());
				noPassReason.setLessonId(lessonId);
				noPassReason.setCreateByTime(material.getUpdateTime());  //如果通过，创建时间就是更新时间
				noPassReason.setAuditorId(material.getUpdateById());
				noPassReason.setState(3);
				list2.add(noPassReason);
			}
		}
		Page<LessonReply> page=new Page<LessonReply>(pageNo,pageSize,"create_by_time",false);
		LessonReply lessonReply=new LessonReply();
		lessonReply.setLessonId(lessonId);
		EntityWrapper<LessonReply> wrapper=new EntityWrapper<LessonReply>(lessonReply);
		List<LessonReply> list=this.selectPage(page, wrapper).getRecords();
		
		if(!CollectionUtils.isEmpty(list)) {
			for (int i = 0; i < list.size(); i++) {
				LessonReply lessonReply2=list.get(i);
				NoPassReason noPassReason=new NoPassReason();
				BeanUtils.copyProperties(lessonReply2,noPassReason);
				noPassReason.setState(4);//4不通过
				list2.add(noPassReason);
			}
		}
		return list2;
	}

	@Override
	public LessonReply getLastNoPassReasonByLessonId(Long lessonId) {
		// TODO Auto-generated method stub
		
		return lessonReplyMapper.getLastNoPassReplyByLessonId(lessonId);
	}

	

}
