package com.yizhi.course.application.service.impl;

import com.yizhi.course.application.domain.RichMedia;
import com.yizhi.course.application.mapper.RichMediaMapper;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.course.application.service.IRichMediaService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * <p>
 * 课程富媒体保存 服务实现类
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
@Service
@Transactional(rollbackFor = Exception.class)
public class RichMediaServiceImpl extends ServiceImpl<RichMediaMapper, RichMedia> implements IRichMediaService {

	@Override
	public RichMedia getRichMediaByMaterialId(Long materialId) {
		// TODO Auto-generated method stub
		RichMedia richMedia=new RichMedia();
		richMedia.setMaterialId(materialId);
		richMedia.setDeleted(0);
		EntityWrapper<RichMedia> wrapper=new EntityWrapper<RichMedia>(richMedia);
		return this.selectOne(wrapper);
	}

	@Override
	public Boolean deleteByMaterialId(Long materialId) {
		// TODO Auto-generated method stub
		RichMedia richMedia=new RichMedia();
		richMedia.setMaterialId(materialId);
		richMedia.setDeleted(1);
		EntityWrapper<RichMedia> wrapper=new EntityWrapper<RichMedia>(richMedia);
		return this.update(richMedia,wrapper);
	}

}
