package com.yizhi.course.application.service.impl;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.course.application.domain.StatisticsCourse;
import com.yizhi.course.application.domain.StatisticsCourseLearn;
import com.yizhi.course.application.mapper.StatisticsCourseMapper;
import com.yizhi.course.application.service.ICourseService;
import com.yizhi.course.application.service.IStatisticsCourseService;
import com.yizhi.course.application.vo.*;
import org.apache.ibatis.session.RowBounds;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author wangfeida123
 * @since 2018-07-26
 */
@Service
public class StatisticsCourseServiceImpl extends ServiceImpl<StatisticsCourseMapper, StatisticsCourse>
		implements IStatisticsCourseService {

	@Autowired
	private StatisticsCourseMapper statisticsCourseMapper;
	@Autowired
	private ICourseService courseService;

	@Override
	public List<ReportStudyCourseChartsVo> chartGroup(String startDate, String endDate, Long companyId, List<Long> orgIds,
													  Long siteId) {
		// TODO Auto-generated method stub
		// 补数据 如果七月一号这一天没有记录，则此表也没有记录，因此补出这一天的数据
		List<ReportStudyCourseChartsVo> list = statisticsCourseMapper.chartGroup(startDate, endDate, companyId, orgIds,siteId);
		List<ReportStudyCourseChartsVo> listAllRecord = new ArrayList<ReportStudyCourseChartsVo>();
		Date startDate1, endDate1;
		ReportStudyCourseChartsVo rsccvUpdate =null;
		int num = 0;
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		try {
			startDate1 = dateFormat.parse(startDate);
			endDate1 = dateFormat.parse(endDate);
			num = (int) ((endDate1.getTime() - startDate1.getTime()) / (1000 * 3600 * 24));
			Date updateDate = startDate1;
			String updateDateValue = dateFormat.format(updateDate);
			Boolean isTrue = false;
			int j=0;
			for (int i = 0; i <= num; i++) {
				if (list != null&&list.size()>0) {
					if(j<list.size()) {
						ReportStudyCourseChartsVo rsccv = list.get(j);
						if (rsccv.getValue().equals(updateDateValue)) {
							j=j+1;
							listAllRecord.add(rsccv);
							isTrue = true;
						}
						else {
							isTrue=false;
						}
					}
			    }
				if (!isTrue) {
					rsccvUpdate = new ReportStudyCourseChartsVo();
					rsccvUpdate.setValue(updateDateValue);
					rsccvUpdate.setTotalCourse(0);
					rsccvUpdate.setTotalAccount(0);
					rsccvUpdate.setTotalCount(0);
					listAllRecord.add(rsccvUpdate);
					
				}
				Calendar c = Calendar.getInstance();
				c.setTime(updateDate);
				c.add(Calendar.DAY_OF_MONTH, 1); // 利用Calendar 实现 Date日期+1天
				updateDate = c.getTime();
				updateDateValue = dateFormat.format(updateDate);
				isTrue=false;
			}
			
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return listAllRecord;
	}

	@Override
	public Page<ReportStudyCourseVo> courseGroup(String kwd, String startDate, String endDate, Long companyId,
												 List<Long> orgIds, Long siteId, Integer pageNo, Integer pageSize) {
		if(pageNo==null||pageSize==null) {
			pageNo=1;
			pageSize=Integer.MAX_VALUE;
		}
		
		List<Long> siteIds = new ArrayList<Long>();
		siteIds.add(siteId);
		
		//先分页查询出要统计的课程ID
		Map<String, Object> paramMap = new HashMap<String, Object>();
		paramMap.put("type", "courseGroup");
		paramMap.put("kwd", kwd);
		paramMap.put("companyId", companyId);
		paramMap.put("startDate", startDate);
		paramMap.put("endDate", endDate);
		paramMap.put("siteIds", siteIds);
		paramMap.put("orgIds", orgIds);
		Page<Long> courseIds = selectLearnOnCourses(paramMap, pageNo, pageSize);
		if(courseIds == null || courseIds.getRecords() == null || courseIds.getRecords().size() == 0){
			return new Page<ReportStudyCourseVo>(pageNo, pageSize);
		}
		BigDecimal b;
		BigDecimal big;
		//拿着这些课程ID进行统计
		Page<ReportStudyCourseVo> page = new Page<ReportStudyCourseVo>(pageNo, pageSize);
		List<ReportStudyCourseVo> list = statisticsCourseMapper.courseGroup(courseIds.getRecords(), startDate, endDate);
		for(ReportStudyCourseVo rscv : list){
			if(rscv.getTotalDuration() == null){
				rscv.setAvgDuration("0.0");
			}else if (rscv.getTotalCount() != 0){
				b=new BigDecimal(Double.valueOf(rscv.getTotalDuration()));
				big = new BigDecimal(rscv.getTotalCount());
				rscv.setAvgDuration(b.divide(big,1,BigDecimal.ROUND_HALF_UP).toString());
			}else {
				rscv.setAvgDuration(rscv.getTotalDuration());
			}
		}
		page.setRecords(list);
		page.setTotal(courseIds.getTotal());
		
		return page;
	}

	@Override
	public Page<ReportStudyCourseAccountVo> courseAccountGroup(String orgKwd, String accountKwd, String startDate,
															   String endDate, Long companyId, List<Long> orgIds, Long siteId, Integer pageNo, Integer pageSize) {
		// TODO Auto-generated method stub
		if(pageNo==null||pageSize==null) {
			pageNo=1;
			pageSize=Integer.MAX_VALUE;
		}
		
		List<Long> siteIds = new ArrayList<Long>();
		siteIds.add(siteId);
		
		//先分页查询出要统计的课程ID
		Map<String, Object> paramMap = new HashMap<String, Object>();
		paramMap.put("type", "accountGroup");
		paramMap.put("orgKwd", orgKwd);
		paramMap.put("startDate", startDate);
		paramMap.put("endDate", endDate);
		paramMap.put("accountKwd", accountKwd);
		paramMap.put("companyId", companyId);
		paramMap.put("siteIds", siteIds);
		paramMap.put("orgIds", orgIds);
		
		Page<Long> accountGroup = selectLearnOnAccounts(paramMap, pageNo, pageSize);
		if(accountGroup == null || accountGroup.getRecords() == null || accountGroup.getRecords().size() == 0){
			return new Page<ReportStudyCourseAccountVo>(pageNo, pageSize);
		}
		
		//拿着这些课程ID进行统计
		Page<ReportStudyCourseAccountVo> page = new Page<ReportStudyCourseAccountVo>(pageNo, pageSize);
		List<ReportStudyCourseAccountVo> list = statisticsCourseMapper.courseAccountGroup(accountGroup.getRecords(), startDate, endDate);
		/*BigDecimal bigDecimal = new BigDecimal(60);
		for(ReportStudyCourseAccountVo vo : list){
			vo.setTotalDuration(vo.getTotalDuration().divide(bigDecimal,1,BigDecimal.ROUND_HALF_UP));
            System.out.println("vo.getTotalDuration() = " + vo.getTotalDuration());
		}*/
		for(ReportStudyCourseAccountVo vo : list){
			if(vo.getTotalDuration() == null){
				vo.setTotalDuration("0.0");
			}
		}
		page.setRecords(list);
		page.setTotal(accountGroup.getTotal());
		return page;
	}
	
	
	
	@Override
	public Page<ReportStudyCourseAccountVo> courseAccountGroupExport(String orgKwd, String accountKwd, String startDate,
			String endDate, Long companyId, List<Long> orgIds, Long siteId, Integer pageNo, Integer pageSize) {
		// TODO Auto-generated method stub
		
		if(pageNo==null||pageSize==null) {
			pageNo=1;
			pageSize=Integer.MAX_VALUE;
		}
		
		List<Long> siteIds = new ArrayList<Long>();
		siteIds.add(siteId);
		
		//先分页查询出要统计的课程ID
		Map<String, Object> paramMap = new HashMap<String, Object>();
		paramMap.put("type", "accountGroup");
		paramMap.put("orgKwd", orgKwd);
		paramMap.put("startDate", startDate);
		paramMap.put("endDate", endDate);
		paramMap.put("accountKwd", accountKwd);
		paramMap.put("companyId", companyId);
		paramMap.put("siteIds", siteIds);
		paramMap.put("orgIds", orgIds);
		
		Page<ReportStudyCourseAccountVo> page=new Page<ReportStudyCourseAccountVo>(pageNo,pageSize);
		Integer count=0;
		if(pageNo<=1) {
			count = statisticsCourseMapper.selectLearnOnAccountsTotal(paramMap);
		}
		RowBounds row = new RowBounds(page.getOffset(), page.getLimit());
		List<ReportStudyCourseAccountVo> list = statisticsCourseMapper.courseAccountGroupExport(paramMap, row);
		if(!CollectionUtils.isEmpty(list)) {
			page.setRecords(list);
			page.setTotal(count);	
		}
		return page;
	}
	
	
	
	
	@Override
	public List<ReportStudyCourseAccountDetailsVo> courseAccountDetails(String orgKwd, String accountKwd, String startDate, String endDate,
																		Long companyId, List<Long> orgIds, Long siteId, Integer pageNo, Integer pageSize) {
		// TODO Auto-generated method stub
		Map<String,Object> paramMap=new HashMap<String,Object>();
		
		paramMap.put("orgKwd", orgKwd);
		paramMap.put("accountKwd", accountKwd);
		paramMap.put("startDate", startDate);
		paramMap.put("endDate", endDate);
		paramMap.put("companyId", companyId);
		paramMap.put("orgIds", orgIds);
		paramMap.put("siteId", siteId);
		paramMap.put("start", pageNo*pageSize);
		paramMap.put("pageSize", pageSize);
		
		List<ReportStudyCourseAccountDetailsVo> list=statisticsCourseMapper.courseAccountDetails(paramMap);
		return list;
	}
	
	
	
	@Override
	public Integer courseAccountDetailsDataTotal(String orgKwd, String accountKwd, String startDate, String endDate,
			Long companyId, List<Long> orgIds, Long siteId) {
		// TODO Auto-generated method stub
		Map<String,Object> paramMap=new HashMap<String,Object>();
		
		paramMap.put("orgKwd", orgKwd);
		paramMap.put("accountKwd", accountKwd);
		paramMap.put("startDate", startDate);
		paramMap.put("endDate", endDate);
		paramMap.put("companyId", companyId);
		paramMap.put("orgIds", orgIds);
		paramMap.put("siteId", siteId);
		
		Integer dataTotal=statisticsCourseMapper.courseAccountDetailsDataTotal(paramMap);
		return dataTotal;
	}
	
	
	
	
	

	@Override
	public Page<ReportStudyCourseOrgVo> courseOrgGroup(String kwd, String startDate, String endDate, Long companyId,
													   List<Long> orgIds, Long siteId, Integer pageNo, Integer pageSize) {
		// TODO Auto-generated method stub
		if(pageNo==null||pageSize==null) {
			pageNo=1;
			pageSize=Integer.MAX_VALUE;
		}
		
		List<Long> siteIds = new ArrayList<Long>();
		siteIds.add(siteId);
		
		//先分页查询出要统计的课程ID
		Map<String, Object> paramMap = new HashMap<String, Object>();
		paramMap.put("type", "orgGroup");
		paramMap.put("startDate", startDate);
		paramMap.put("endDate", endDate);
		paramMap.put("orgKwd", kwd);
		paramMap.put("companyId", companyId);
		paramMap.put("siteIds", siteIds);
		paramMap.put("orgIds", orgIds);
		Page<Long> orgGroup = selectLearnOnCourses(paramMap, pageNo, pageSize);
		if(orgGroup == null || orgGroup.getRecords() == null || orgGroup.getRecords().size() == 0){
			return new Page<ReportStudyCourseOrgVo>(pageNo, pageSize);
		}
		
		//拿着这些课程ID进行统计
		BigDecimal b;
		BigDecimal big;
		Page<ReportStudyCourseOrgVo> page = new Page<ReportStudyCourseOrgVo>(pageNo, pageSize);
		List<ReportStudyCourseOrgVo> list = statisticsCourseMapper.courseOrgGroup(companyId, siteIds, orgGroup.getRecords(), startDate, endDate);
		for(ReportStudyCourseOrgVo rscv : list){
			if(rscv.getTotalDuration() == null){
				rscv.setAvgDuration("0.0");
			}else if (rscv.getTotalCount() != 0){
				b=new BigDecimal(Double.valueOf(rscv.getTotalDuration()));
				big = new BigDecimal(rscv.getTotalCount());
				rscv.setAvgDuration(b.divide(big,1,BigDecimal.ROUND_HALF_UP).toString());
			}else {
				rscv.setAvgDuration(rscv.getTotalDuration());
			}
		}
		page.setRecords(list);
		page.setTotal(orgGroup.getTotal());
		
		return page;
	}

	@Override
	public Map<String,Object> CourseGroupView(String orgKwd, String accountKwd, String startDate,
			String endDate, Long courseId, Integer pageNo, Integer pageSize) {
		// TODO Auto-generated method stub
		if(pageNo==null||pageSize==null) {
			pageNo=1;
			pageSize=Integer.MAX_VALUE;
		}
		Page<ReportStudyCourseViewVo> page = new Page<ReportStudyCourseViewVo>(pageNo, pageSize);
		List<ReportStudyCourseViewVo> list = statisticsCourseMapper.CourseGroupView(orgKwd, accountKwd, courseId,
				startDate, endDate, page);
		page.setRecords(list);
		
		//数据装在map中
		Map<String,Object> map=new HashMap<String,Object>();
		
		
		map.put("list", list);
		map.put("pageTotal", page.getTotal());
		map.put("cname", courseService.selectById(courseId).getName());
		
		return map;
	}

	@Override
	public Map<String,Object> courseAccountGroupView(Long accountId, String kwd, String startDate,
			String endDate, Integer pageNo, Integer pageSize) {
		// TODO Auto-generated method stub
		if(pageNo==null||pageSize==null) {
			pageNo=1;
			pageSize=Integer.MAX_VALUE;
		}
		Page<ReportStudyCourseAccountViewVo> page = new Page<ReportStudyCourseAccountViewVo>(pageNo, pageSize);
		List<ReportStudyCourseAccountViewVo> list = statisticsCourseMapper.courseAccountGroupView(accountId, kwd,
				startDate, endDate, page);
		page.setRecords(list);
		String accountName=statisticsCourseMapper.selectAccountNameByaccountId(accountId);
		Map<String,Object> map=new HashMap<String,Object>();
		map.put("list", list);
		map.put("pageTotal", page.getTotal());
		map.put("accountName",accountName);
		return map;
	}

	@Override
	public List<StatisticsCourseLearn> insertAccountLearn(Long courseId, String curDate) {
		int count = statisticsCourseMapper.insertAccountLearn(courseId, curDate);
		
		
		/*int insertAccountLearnGrade=statisticsCourseMapper.insertAccountLearnGrade(courseId, curDate);
		
		int insertAccountLearnCommen=statisticsCourseMapper.insertAccountLearnCommen(courseId, curDate);*/
		
		if(count == 0){
			return null;
		}
		
		
		
		
		return statisticsCourseMapper.selectAccountLearn(courseId, curDate);
	}

	@Override
	@Deprecated
	public Page<Long> selectAccountLearnList(Map<String, Object> paramMap, int pageNo, int pageSize) {
		Page<Long> page = new Page<Long>(pageNo, pageSize);
		List<Long> ids = statisticsCourseMapper.selectAccountLearnList(paramMap, page);
		page.setRecords(ids);
		return page;
	}

	@Override
	public Page<Long> selectLearnOnCourses(Map<String, Object> paramMap, int pageNo, int pageSize) {
		Page<Long> page = new Page<Long>(pageNo, pageSize);
		RowBounds row = new RowBounds(page.getOffset(), page.getLimit());
		Integer count = statisticsCourseMapper.selectLearnOnCoursesTotal(paramMap);
		List<Long> ids = statisticsCourseMapper.selectLearnOnCourses(paramMap, row);
		page.setRecords(ids);
		page.setTotal(count);
		
		return page;
	}

	@Override
	public Page<Long> selectLearnOnAccounts(Map<String, Object> paramMap, int pageNo, int pageSize) {
		Page<Long> page = new Page<Long>(pageNo, pageSize);
		RowBounds row = new RowBounds(page.getOffset(), page.getLimit());
		Integer count = statisticsCourseMapper.selectLearnOnAccountsTotal(paramMap);
		List<Long> ids = statisticsCourseMapper.selectLearnOnAccounts(paramMap, row);
		page.setRecords(ids);
		page.setTotal(count);
		return page;
	}


	

	

}
