package com.yizhi.course.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.course.application.domain.ThumbsUp;
import com.yizhi.course.application.mapper.ThumbsUpMapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.course.application.service.IThumbsUpService;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 我的点赞 服务实现类
 * </p>
 *
 * @author fulan123
 * @since 2018-03-19
 */
@Service
@Transactional(rollbackFor = Exception.class)
public class ThumbsUpServiceImpl extends ServiceImpl<ThumbsUpMapper, ThumbsUp> implements IThumbsUpService {

    @Override
    public Boolean judgeHasThumbsUp(Long courseId, Long commentId) {
        RequestContext context = ContextHolder.get();
        ThumbsUp thumbsUp = new ThumbsUp();
        thumbsUp.setAccountId(context.getAccountId());
        thumbsUp.setCommentId(commentId);
        thumbsUp.setCompanyId(context.getCompanyId());
        thumbsUp.setCourseId(courseId);
        EntityWrapper<ThumbsUp> entityWrapper = new EntityWrapper<>(thumbsUp);
        if (this.baseMapper.selectCount(entityWrapper) > 0) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 获取点赞信息
     *
     * @param siteId
     * @param commentIds
     * @param accountId
     * @return
     */
    @Override
    public Map<Long, ThumbsUp> getThumbsInfo(Long siteId, List<Long> commentIds, Long accountId) {
        List<ThumbsUp> data = this.baseMapper.getThumbsInfo(siteId,commentIds);
        Map<Long, ThumbsUp> retData = null;
        if(CollectionUtils.isNotEmpty(data)){
            retData = new HashMap<>();
            List<Long> dataUser = this.baseMapper.getThumbsInfoByUser(accountId,siteId,commentIds);
            for(ThumbsUp item : data){
                Long key = item.getCommentId();
                if(CollectionUtils.isNotEmpty(dataUser) && dataUser.contains(key)){
                    item.setHasThumbsUp(true);
                }else{
                    item.setHasThumbsUp(false);
                }
                retData.put(key,item);
            }
        }
        return retData;
    }
}
