package com.yizhi.course.application.task;

import java.io.File;
import java.io.FileOutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

import com.yizhi.core.application.context.TaskContext;
import com.yizhi.core.application.file.constant.FileConstant;
import com.yizhi.core.application.file.task.AbstractDefaultTask;
import com.yizhi.core.application.file.util.OssUpload;
import com.yizhi.course.application.domain.Reply;
import com.yizhi.course.application.service.ICommentService;
import com.yizhi.course.application.service.IReplyService;
import com.yizhi.course.application.vo.ListCommentVo;
import com.yizhi.system.application.system.remote.AccountClient;
import com.yizhi.system.application.vo.AccountIdsByKeyReqVO;
import com.yizhi.system.application.vo.AccountVO;
import org.apache.commons.lang.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.VerticalAlignment;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFFont;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.baomidou.mybatisplus.mapper.EntityWrapper;

@Component
public class CommentListExportAsync extends AbstractDefaultTask<String, Map<String,Object>> {

	private static final Logger logger = LoggerFactory.getLogger(CommentListExportAsync.class);
	
	@Autowired
	private ICommentService commentService;
	
	@Autowired
	private IReplyService replyService;
	
	@Autowired
	private AccountClient accountClient;
	
	@Override
	protected String execute(Map<String, Object> arg0) {
		Long accountId=(Long) arg0.get("accountId");
		Long siteId=(Long) arg0.get("siteId");
		Long companyId=(Long) arg0.get("companyId");
		Long taskId=(Long) arg0.get("taskId");
		Date submitTime=(Date) arg0.get("submitTime");
		String serialNo=(String) arg0.get("serialNo");
		String taskName=(String) arg0.get("taskName");
		Integer status=(Integer) arg0.get("status");
		String commentator=(String) arg0.get("commentator");
		Long coursrId=(Long) arg0.get("courseId");
		String courseName=(String) arg0.get("courseName");
		/**
		 * 走异步任务
		 */
        TaskContext taskContext = new TaskContext(taskId, serialNo, taskName, accountId, submitTime, siteId, companyId);
		working(taskContext);		
		String upLoadUrl=null;
		String requestPath= FileConstant.SAVE_PATH;
		File fileDir=new File(requestPath);
		if(!fileDir.exists()) {
			fileDir.mkdir();
		}	
		//课程清单开始组装
		List<ListCommentVo> listVO=new ArrayList<ListCommentVo>();
		List<ListCommentVo> list = null;
		List<Long> accountIds = new ArrayList<Long>();
		if (StringUtils.isNotBlank(commentator)) {
			AccountIdsByKeyReqVO vo = new AccountIdsByKeyReqVO();
			vo.setKey(commentator);
			vo.setCompanyId(companyId);
			vo.setSiteId(siteId);
			accountIds = accountClient.findAIdsByKeywordByVo(vo);
			if (accountIds==null) {
				list = new ArrayList<ListCommentVo>();
			}
			list = commentService.getCommentList(coursrId, accountIds, status);
		}else {
			list = commentService.getCommentList(coursrId, accountIds, status);
		}
		Reply reply = new Reply();
		ListCommentVo vo = new ListCommentVo();
		for(ListCommentVo commentVo:list) {
			AccountVO accountVO = accountClient.findById(commentVo.getAccountId());
			commentVo.setCommentatorName(null==accountVO.getFullName()||""==accountVO.getFullName()?accountVO.getName():accountVO.getFullName());
			commentVo.setReplyName(courseName);
			commentVo.setCommentator(accountVO.getName());
			reply.setCommentId(commentVo.getId());
			reply.setDeleted(0);
			EntityWrapper<Reply> wrapper = new EntityWrapper<Reply>(reply);
			List<String> time = new ArrayList<String>();
			time.add("createTime");
			wrapper.orderDesc(time);
			List<Reply> replyList = replyService.selectList(wrapper);
			listVO.add(commentVo);
			for(Reply r:replyList) {
				ListCommentVo vo1 = new ListCommentVo();
				if (null!=r.getReplyParentId()&&0!=r.getReplyParentId()) {
					Long accountId1 = replyService.selectById(r.getReplyParentId()).getAccountId();
					AccountVO findById = accountClient.findById(accountId1);
					r.setParentAccountFullName(null==findById.getFullName()||""==findById.getFullName()?findById.getName():findById.getFullName());
				}else {
					AccountVO findById = accountClient.findById(commentService.selectById(r.getCommentId()).getAccountId());
					r.setParentAccountFullName(null==findById.getFullName()||""==findById.getFullName()?findById.getName():findById.getFullName());
				}
				logger.info("-----");
				AccountVO findById = accountClient.findById(r.getAccountId());
				vo1.setId(r.getId());
				vo1.setAccountId(r.getAccountId());
				vo1.setCommentator(findById.getName());
				vo1.setCommentatorName(null==findById.getFullName()||""==findById.getFullName()?findById.getName():findById.getFullName());
				vo1.setReplyName(r.getParentAccountFullName());
				vo1.setContent(r.getContent());
				vo1.setCreateTime(r.getCreateTime());
				vo1.setStatus(r.getStatus());
				vo1.setThumbsUp(0);
				vo1.setLevel(0);
				listVO.add(vo1);
			}
		}
		SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"); 	
		SimpleDateFormat sf = new SimpleDateFormat("yyyyMMddHHmmss"); 	 	
		try {
			//excel生成过程: excel-->sheet-->row-->cell
			// 第一步，创建一个Excel文件
			XSSFWorkbook wb = new XSSFWorkbook();
			// 第二步，在webbook中添加一个sheet,对应Excel文件中的sheet
			XSSFSheet sheet = wb.createSheet("评论信息");
			XSSFFont font = wb.createFont();
			font.setFontName("宋体");
			font.setFontHeightInPoints((short) 11);
			font.setBold(true);
			XSSFCellStyle style = wb.createCellStyle();
			style.setFont(font);
			style.setAlignment(HorizontalAlignment.CENTER); // 创建一个居中格式
			style.setVerticalAlignment(VerticalAlignment.CENTER);
			// 第三步，在sheet中添加表头第0行,注意老版本poi对Excel的行数列数有限制short
			XSSFRow row = sheet.createRow((int) 0);
			row.setHeight((short) (20*20));
			// 合并单元格  
			CellRangeAddress cra=new CellRangeAddress(0,0,0,7); // 起始行, 终止行, 起始列, 终止列  
			sheet.addMergedRegion(cra);
			XSSFCell cell = row.createCell((short) 0);
			cell.setCellValue(courseName+"课程评论记录"+sf.format(submitTime));
			cell.setCellStyle(style);
			// 第三步，在sheet中添加表头第0行,注意老版本poi对Excel的行数列数有限制short
			XSSFRow row2 = sheet.createRow((int) 1);
			row2.setRowStyle(style);
			row2.setHeight((short) (14*20));
			// 第四步，创建单元格
			row2.createCell((short) 0).setCellValue("评论人/回复人"); 
			row2.createCell((short) 1).setCellValue("姓名"); 
			row2.createCell((short) 2).setCellValue("星级（评分）"); 
			row2.createCell((short) 3).setCellValue("评论对象"); 
			row2.createCell((short) 4).setCellValue("评论内容"); 
			row2.createCell((short) 5).setCellValue("提交时间"); 
			row2.createCell((short) 6).setCellValue("点赞数"); 
			row2.createCell((short) 7).setCellValue("状态"); 
			
				for(int i=0;i<listVO.size();i++) {
					font.setBold(false);
					row = sheet.createRow(i + 2);
					row.setRowStyle(style);
					row.setHeight((short) (13*20));
					// 第四步，创建单元格，并设置值
					vo=listVO.get(i);
					if(vo!=null&&vo.getCommentator()!=null) {
						row.createCell((short) 0).setCellValue(vo.getCommentator());
					}
					if(vo!=null&&vo.getCommentatorName()!=null) {
						row.createCell((short) 1).setCellValue(null==vo.getCommentatorName()?"":vo.getCommentatorName());
					}				
					if(vo!=null&&vo.getLevel()!=null) {
						row.createCell((short) 2).setCellValue(0==vo.getLevel()?"--":vo.getLevel()+"星");
					}				
					if(vo!=null&&vo.getReplyName()!=null) {
						row.createCell((short) 3).setCellValue(null==vo.getReplyName()?"":vo.getReplyName());
					}
					if(vo!=null&&vo.getContent()!=null) {
							row.createCell((short) 4).setCellValue(vo.getContent());
					}					
					if(vo!=null&&vo.getCreateTime()!=null) {
					    row.createCell((short) 5).setCellValue(df.format(vo.getCreateTime()));
					}
					if (vo!=null&&vo.getThumbsUp()!=null) {
							    row.createCell((short) 6).setCellValue(null==vo.getThumbsUp()?"--":vo.getThumbsUp().toString());
					}
					if (vo!=null&&vo.getStatus()!=null) {
					    row.createCell((short) 7).setCellValue(0==vo.getStatus()?"已上架":"已下架");
			}
				}	
				
			// 第五步，写入实体数据 实际应用中这些数据从数据库得到，
			StringBuffer fileNameSb = new StringBuffer().append("课程评论记录").append(sf.format(submitTime)).append(".xlsx");
			String fileName = fileNameSb.toString();
			String path = new StringBuffer().append(requestPath).append(fileNameSb).toString();
			FileOutputStream os=null;
			File file=null;
			try {
				os= new FileOutputStream(path);
				wb.write(os);
				//阿里云返回url
				upLoadUrl = OssUpload.upload(path, fileName);
				file=new File(path);
				success(taskContext,"成功", upLoadUrl);
			} catch (Exception e1) {
				e1.printStackTrace();
				fail(taskContext, "写入数据到Excel的过程中或者上传到阿里云中发生错误"+e1.getMessage());
				logger.error("写入数据到Excel的过程中或者上传到阿里云中发生错误"+e1.getMessage());	
			}
			finally {
				if(os!=null) {
				   os.close();
				}
				if(wb!=null) {
				   wb.close();
				}
				if(file!=null) {
				   file.delete();
				}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			fail(taskContext, "评论信息导出过程中发生错误，请查看日志"+e.getMessage());	
			logger.error("评论信息导出过程中发生错误，请查看日志"+e.getMessage());
		}
		return upLoadUrl;
	}
}
