package com.yizhi.course.application.util;

public class MaterialDateUtil {

    /**
     * 转换视频时长为hh:mm:ss/mm:ss
     * @param videoSeconds 视频时长
     * @return hh:mm:ss 格式的字符串
     */
    public static String transformSecondsToHms(Integer videoSeconds){
        String timeStr = null;
        int hour = 0;
        int minute = 0;
        int second = 0;
        if (videoSeconds <= 0)
            return "00:00:00";
        else {
            minute = videoSeconds / 60;
            if (minute < 60) {
                second = videoSeconds % 60;
                timeStr = "00:" + unitFormat(minute) + ":" + unitFormat(second);
            } else {
                hour = minute / 60;
                if (hour > 99)
                    return "99:59:59";
                minute = minute % 60;
                second = videoSeconds - hour * 3600 - minute * 60;
                timeStr = unitFormat(hour) + ":" + unitFormat(minute) + ":" + unitFormat(second);
            }
        }
        return timeStr;
    }

    public static String unitFormat(int i) {
        String retStr = null;
        if (i >= 0 && i < 10)
            retStr = "0" + Integer.toString(i);
        else
            retStr = "" + i;
        return retStr;
    }
}
