package com.yizhi.course.application.controller;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.course.application.vo.HomePageCoursePageVo;
import com.yizhi.course.application.vo.HomePageCoursePageVoV2;
import com.yizhi.course.application.vo.RemoteDaIndicatorVo;
import com.yizhi.course.application.vo.ReportStudyCourseAccountVo;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.Date;
import java.util.List;

@RunWith(SpringRunner.class)
@SpringBootTest
public class CourseTest {

    @Autowired
    private StatisticsCourseController statisticsCourseController;
    @Autowired
    private RemoteDaIndicatorController indicatorController;

    @Test
    public void test() {
        Page<ReportStudyCourseAccountVo> page = statisticsCourseController.courseAccountGroupExport(null, null, "2018-11-01", "2018-11-29", 1314L, 1314L, 1314L, 1, 30);
        System.out.println(page.getTotal());
    }

    @Test
    public void testDashboard() {
        indicatorController.courseTime(
                new RemoteDaIndicatorVo(1314L, DateUtil.parseDate("2019-09-02"),
                        DateUtil.parseDate("2019-09-08"), DateUtil.parseDate("2019-10-11"), new Date())
        );
    }

    @Autowired
    CoursePcController coursePcController;

    /**
     * 课程列表 v2
     */
    @Test
    public void pcCourseListV2Test(){
        Page<HomePageCoursePageVoV2> homePageCoursePageVoPage = coursePcController.listCourseInfoV2(null, 1, 1000, false, null, null);
        Page<HomePageCoursePageVoV2> homePageCoursePageVoPage2 = coursePcController.listCourseInfoV2(null, 1, 1000, false, null, true);
        Page<HomePageCoursePageVoV2> homePageCoursePageVoPage3 = coursePcController.listCourseInfoV2(null, 1, 1000, false, true, null);
        System.out.println(homePageCoursePageVoPage);
    }

    /**
     * 推荐课程列表 v2
     */
    @Test
    public void pcRecommendCourseListV2Test(){
        List<HomePageCoursePageVoV2> coursePageVoV2List = coursePcController.recommendV2();
        System.out.println(coursePageVoV2List);
    }
}
